<?php
require_once dirname( __FILE__ ) . '/helpers.php';
require_once dirname( __FILE__ ) . '/Event.php';
require_once dirname( __FILE__ ) . '/eventCard.php';
require_once dirname( __FILE__ ) . '/eventCardExtended.php';
require_once dirname( __FILE__ ) . '/AddOnManager.php';
require_once dirname( __FILE__ ) . '/libs/googleCal/GoogleCalendar.class.php';
class EventBookingAdmin {

  var $main, $path, $name, $url;


  public static function getVersion() {
    return "3.5";
  }

  public static function fixActivate() {
    EventBookingAdmin::activate();
  }

  function __construct($file) {
    $this->main = $file;
    $this->version = EventBookingAdmin::getVersion();
    $this->mobileBookingPage_title = 'Mobile Booking Page';
    $this->mobileBookingPage_name = 'Mobile-Booking-Page';
    $this->mobileBookingPage_desc = "DO NOT DELETE THIS PAGE! It is the booking page on mobile.";

    $this->minified = ""; //min.
    $this->init();

    return $this;
  }

  function template_loader( $template ) {
    global $post;
        if ($post->ID == get_option('ebp_page_id'))
            return $this->path.'/mobileBookingPage.php';
        return $template;
  }

  function init() {
    $this->path = dirname( __FILE__ );
    $this->name = basename( $this->path );
    $this->url = plugins_url( "/{$this->name}/" );

    if (is_admin()) {

      register_activation_hook( $this->main , array(&$this, 'activate') );
      register_deactivation_hook( $this->main , array(&$this, 'deactivate') );

      //Register Ajax Calls
      add_action('admin_menu', array(&$this, 'admin_menu'));
      add_action('wp_ajax_ebp_event_save', array(&$this, 'saveEvent'));
      add_action('wp_ajax_event_fetch', array(&$this, 'getEvent'));
      add_action('wp_ajax_event_booking_main', array(&$this, 'getBookingMarkUp'));
      add_action('wp_ajax_event_booking_fetch', array(&$this, 'getBookingEcho'));
      add_action('wp_ajax_event_ShortCode', array(&$this, 'getEventShortCode'));
      add_action('wp_ajax_booking_delete', array(&$this, 'deleteBooking'));
      add_action('wp_ajax_booking_edit', array(&$this, 'editBooking'));
      add_action('wp_ajax_ebp_event_delete', array(&$this, 'deleteEvent'));
      add_action('wp_ajax_ebp_settings', array(&$this, 'getSettings'));
      add_action('wp_ajax_ebp_save_settings', array(&$this, 'saveSettings'));
      add_action('wp_ajax_get_coupons', array(&$this, 'getAllCoupons'));
      add_action('wp_ajax_coupon_fetch', array(&$this, 'getCoupon'));
      add_action('wp_ajax_coupon_save', array(&$this, 'saveCoupon'));
      add_action('wp_ajax_coupon_delete', array(&$this, 'deleteCoupon'));
      add_action('wp_ajax_event_coupon_fetch', array(&$this, 'getEventCoupons'));
      add_action('wp_ajax_event_coupon_update', array(&$this, 'updateEventCoupon'));
      add_action('wp_ajax_check_coupon', array(&$this, 'checkCoupon'));
      add_action('wp_ajax_check_spots', array(&$this, 'ajax_checkSpots'));
      add_action('wp_ajax_get_categories', array(&$this, 'getAllCategories'));
      add_action('wp_ajax_category_fetch', array(&$this, 'getCategory'));
      add_action('wp_ajax_category_save', array(&$this, 'saveCategory'));
      add_action('wp_ajax_category_delete', array(&$this, 'deleteCategory'));
      add_action('wp_ajax_get_event_categories', array(&$this, 'getEventCategories'));
      add_action('wp_ajax_event_categories_update', array(&$this, 'updateEventCategories'));
      add_action('wp_ajax_mark_paid', array(&$this, 'ajax_markPaid'));
      add_action('wp_ajax_event_get_forms', array(&$this, 'ajax_getForms'));
      add_action('wp_ajax_event_get_addons_data', array(&$this, 'ajax_getAddonsData'));
      add_action('wp_ajax_get_email_default_template', array(&$this, 'ajax_getDefaultTemplate'));
      add_action('wp_ajax_get_owner_email_default_template', array(&$this, 'ajax_getDefaultOwnerTemplate'));
      add_action('wp_ajax_checkAddons', array(&$this, 'checkAddons'));
      add_action('wp_ajax_testEmail', array(&$this, 'testEmail'));
      add_action('wp_ajax_getCalData', array(&$this, 'getCalData'));
      add_action('wp_ajax_nopriv_getCalData', array(&$this, 'getCalData'));
      add_action('wp_ajax_getDayEvents', array(&$this, 'getDayEvents'));
      add_action('wp_ajax_nopriv_getDayEvents', array(&$this, 'getDayEvents'));
      add_action('wp_ajax_doEventBooking', array(&$this, 'doEventBooking'));
      add_action('wp_ajax_nopriv_doEventBooking', array(&$this, 'doEventBooking'));
      add_action('wp_ajax_nopriv_check_coupon', array(&$this, 'checkCoupon'));
      add_action('wp_ajax_nopriv_check_spots', array(&$this, 'ajax_checkSpots'));

      add_action('wp_ajax_resendEmail', array(&$this, 'resendEmail'));
      add_action('wp_ajax_fix_mobile_page', array(&$this, 'fixMobileBookingPage'));
      add_action('wp_ajax_ebp_clean_occurences', array(&$this, 'cleanOccurences'));


    } else {

      //register shortcodes
      add_shortcode("eventBox", array(&$this, 'eventBoxShortCode'));
      add_shortcode("eventbox", array(&$this, 'eventBoxShortCode'));
      add_shortcode("eventButton", array(&$this, 'eventButtonShortCode'));
      add_shortcode("eventbutton", array(&$this, 'eventButtonShortCode'));
      add_shortcode("eventCalendar", array(&$this, 'calendarShortcode'));
      add_shortcode("eventcalendar", array(&$this, 'calendarShortcode'));
      add_shortcode("eventsList", array(&$this, 'eventsListShotcode'));
      add_shortcode("eventList", array(&$this, 'eventsListShotcode'));
      add_shortcode("eventslist", array(&$this, 'eventsListShotcode'));
      add_shortcode("eventlist", array(&$this, 'eventsListShotcode'));
      add_shortcode("eventCard", array(&$this, 'eventCardShortCode'));
      add_shortcode("eventcard", array(&$this, 'eventCardShortCode'));

      //call front end files
      add_action('wp', array(&$this, 'frontEndStyle'));
      add_filter( 'template_include', array( &$this, 'template_loader' ) );
    }
  }

  function deactivate() {
    //remove booking page
    $the_page_id = get_option( 'ebp_page_id' );
    if ( $the_page_id )
        wp_delete_post( $the_page_id ); // this will trash, not delete

    delete_option("ebp_page_title");
    delete_option("ebp_page_name");
  }

  function activate() {
    global $wpdb;

    if (!get_option("ebp_update_checker_show")) {
      add_option("ebp_update_checker",true);
      add_option("ebp_update_checker_show",true);
    }


    delete_option("ebp_page_title");
    add_option("ebp_page_title", $this->mobileBookingPage_title, '','yes');

    delete_option("ebp_page_name");
    add_option("ebp_page_name", $this->mobileBookingPage_name, '','yes');

    if (!get_option('ebp_page_id')) {

      // Create post object
      $_p = array();
      $_p['post_title'] = $this->mobileBookingPage_title;
      $_p['post_content'] = $this->mobileBookingPage_desc;
      $_p['post_status'] = 'publish';
      $_p['post_type'] = 'page';
      $_p['comment_status'] = 'closed';
      $_p['ping_status'] = 'closed';
      $_p['post_category'] = array(1); // the default 'Uncatrgorised'

      // Insert the post into the database
      $mobileBookingPage_id = wp_insert_post( $_p );

    } else {

      $mobileBookingPage = get_page( get_option('ebp_page_id') );

      //make sure the page is not trashed...
      $mobileBookingPage->post_status = 'publish';
      $mobileBookingPage_id = wp_update_post( $mobileBookingPage );
    }

    delete_option('ebp_page_id');
    add_option( 'ebp_page_id', $mobileBookingPage_id );


    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

    $categoriesTable = EventBookingHelpers::getTableName("categories");
    $categories_sql = "CREATE TABLE " . $categoriesTable ." (
            id INT NOT NULL AUTO_INCREMENT,
            name VARCHAR(100) NOT NULL,
            PRIMARY KEY (id)
          );";

    $categoryEventsTable = EventBookingHelpers::getTableName("categoryEvents");
    $categoryEvents_sql = "CREATE TABLE " . $categoryEventsTable ." (
            id INT NOT NULL AUTO_INCREMENT ,
            event int NOT NULL,
            category int NOT NULL,
            PRIMARY KEY (id)
          );";

    //coupon table
    $couponsTable = EventBookingHelpers::getTableName("coupons");
    $coupon_sql = "CREATE TABLE " . $couponsTable ." (
            id INT NOT NULL AUTO_INCREMENT,
            code VARCHAR(10) NOT NULL,
            name VARCHAR(100) NOT NULL,
            type VARCHAR(10) default 'single',
            amount VARCHAR(10) NOT NULL,
            isActive VARCHAR(6) NOT NULL,
            maxAllowed INT default '-1',
            PRIMARY KEY (id)
          );";

    $couponsUsedTable = EventBookingHelpers::getTableName("couponsUsed");
    $couponsUsed_sql = "CREATE TABLE " . $couponsUsedTable ." (
            id INT NOT NULL AUTO_INCREMENT,
            coupon INT NOT NULL,
            payment INT NOT NULL,
            date_used date DEFAULT NULL,
            PRIMARY KEY (id)
          );";


    //event table
    $eventTable = EventBookingHelpers::getTableName("events");
    $events_sql = "CREATE TABLE " . $eventTable ." (
            id INT NOT NULL AUTO_INCREMENT ,
            name VARCHAR(255) NOT NULL  ,
            paypal VARCHAR(6) default 'false',
            modal VARCHAR(6) default 'false',
            showPrice VARCHAR(7) default 'true',
            showSpots VARCHAR(7) default 'true',
            info TEXT,
            image VARCHAR(255),
            background VARCHAR(255),
            mapAddressType VARCHAR(20) default 'address',
            mapAddress VARCHAR(255) default '',
            mapZoom int default '16',
            mapType VARCHAR(15) default 'ROADMAP',
            form int default '-1',
            maxSpots int default '-1',
            gateways VARCHAR(255) default '',
            ownerEmail VARCHAR(255) default 'default',
            emailTemplateID int default '-1',
            PRIMARY KEY (id)
          );";


    //event Dates table
    $occurTable = EventBookingHelpers::getTableName("eventDates");
    $occurTable_sql = "CREATE TABLE " . $occurTable ." (
            id INT NOT NULL AUTO_INCREMENT ,
            event INT NOT NULL,
            start_date VARCHAR(20) NOT NULL,
            end_date VARCHAR(20) NOT NULL,
            start_time time NOT NULL,
            end_time time NOT NULL,
            bookingDirectly VARCHAR(6) default 'true',
            startBooking_date VARCHAR(12) default '',
            startBooking_time time,
            bookingEndsWithEvent VARCHAR(6) default 'true',
            endBooking_date VARCHAR(12) default '',
            endBooking_time time,
            PRIMARY KEY (id)
          );";


    //tickets table
    $ticketsTable = EventBookingHelpers::getTableName("tickets");
    $ticketsTable_sql = "CREATE TABLE " . $ticketsTable ." (
            id INT NOT NULL AUTO_INCREMENT ,
            event int NOT NULL,
            name VARCHAR(100) NOT NULL,
            cost DECIMAL(10,2) NOT NULL,
            allowed int NOT NULL,
            PRIMARY KEY (id)
          );";

    //eventCoupons table
    $eventCouponsTable = EventBookingHelpers::getTableName("eventCoupons");
    $eventCouponsTable_sql = "CREATE TABLE " . $eventCouponsTable ." (
            id INT NOT NULL AUTO_INCREMENT ,
            event int NOT NULL,
            coupon int NOT NULL,
            PRIMARY KEY (id)
          );";

    //gateways table
    $gatewaysTable = EventBookingHelpers::getTableName("gateways");
    $gatewaysTable_sql = "CREATE TABLE " . $gatewaysTable ." (
            id INT NOT NULL AUTO_INCREMENT ,
            name VARCHAR(255) NOT NULL,
            module VARCHAR(255) NOT NULL,
            active int default '1',
            PRIMARY KEY (id)
          );";

    //payments
    $paymentTable = EventBookingHelpers::getTableName("payments");
    $payments_sql = "CREATE TABLE " . $paymentTable ." (
            id INT NOT NULL AUTO_INCREMENT ,
            event_id INT NOT NULL,
            date_id INT NOT NULL,
            ticket_id INT NOT NULL,
            date_paid date DEFAULT NULL,
            coupon VARCHAR(100) NOT NULL,
            type VARCHAR(10) DEFAULT NULL,
            name VARCHAR(255) NOT NULL,
            email VARCHAR(255) DEFAULT NULL,
            phone VARCHAR(20) NOT NULL,
            address VARCHAR(255) NOT NULL,
            txn_id VARCHAR(45) DEFAULT NULL,
            amount VARCHAR(10) DEFAULT NULL,
            quantity INT NOT NULL,
            status VARCHAR(45) NOT NULL DEFAULT 'pending',
            extras TEXT NOT NULL,
            came VARCHAR(7) default 'false',
            PRIMARY KEY (id)
          );";

    //settings  table
    $settingsTable = EventBookingHelpers::getTableName("settings");
    $settings_sql = "CREATE TABLE " . $settingsTable ." (
                          id INT NOT NULL AUTO_INCREMENT,
                          paypalAccount VARCHAR(100) default ' ',
                          sandbox VARCHAR(6) default 'false',
                          force_ssl_v3 VARCHAR(6) default 'true',
                          currency VARCHAR(10) default 'USD',
                          couponsEnabled VARCHAR(6) default 'true',
                          multipleBookings VARCHAR(6) default 'true',
                          SMTP_NAME VARCHAR(100) default 'Name in Email',
                          SMTP_EMAIL VARCHAR(255) default 'youremail@host.com',
                          SMTP_PASS VARCHAR(255) default 'password',
                          SMTP_HOST VARCHAR(255) default 'main.domain.com',
                          SMTP_PORT int(10) default '587',
                          emailTitle VARCHAR(255) default ' ',
                          emailSignature VARCHAR(255) default ' ',
                          emailMsg text NOT NULL,
                          cpp_header_image VARCHAR(255) default ' ',
                          cpp_headerback_color VARCHAR(7) default '#FFFFFF',
                          cpp_headerborder_color VARCHAR(7) default '#FFFFFF',
                          cpp_logo_image VARCHAR(255) default ' ',
                          cpp_payflow_color VARCHAR(7) default '#FFFFFF',
                          cal_displayWeekAbbr VARCHAR(5) default 'true',
                          cal_displayMonthAbbr VARCHAR(5) default 'false',
                          cal_startIn int(1) default '1',
                          cal_width int default '600',
                          cal_color VARCHAR(7) default '#2ecc71',
                          cal_bgColor VARCHAR(7) default '#f6f6f6',
                          cal_titleBgColor VARCHAR(7) default '#ffffff',
                          cal_dateColor VARCHAR(7) default '#686a6e',
                          cal_boxColor VARCHAR(7) default '#ffffff',
                          cal_topBorder int default '5',
                          cal_topBorderColor VARCHAR(7) default '#2ecc71',
                          cal_bottomBorder int default '0',
                          cal_bottomBorderColor VARCHAR(7) default '#eeeeee',
                          cal_sideBorder int default '0',
                          cal_sideBorderColor VARCHAR(7) default ' ',
                          cal_paddingSides int default '20',
                          passedTxt VARCHAR(100) default 'Event Passed',
                          bookingStartsTxts VARCHAR(100) default 'Booking starts on %date% @ %time%',
                          bookingEndedTxt VARCHAR(100) default 'Booking ended',
                          bookedTxt VARCHAR(100) default 'No spots left',
                          btnTxt VARCHAR(100) default 'Book',
                          showPrice VARCHAR(5) default 'false',
                          showSpots VARCHAR(7) default 'true',
                          includeEndsOn VARCHAR(5) default 'true',
                          imageMarginSides int default '0',
                          imageCrop VARCHAR(5) default 'true',
                          imageHeight int default '150',
                          imageMarginTop int default '0',
                          imageMarginBottom int default '0',
                          btnColor VARCHAR(7) default '#FFFFFF',
                          btnBgColor VARCHAR(7) default '#2ecc71',
                          btnFontSize int default '18',
                          btnFontType VARCHAR(6) default 'normal',
                          btnLineHeight int default '18',
                          btnSidePadding int default '40',
                          btnTopPadding int default '12',
                          btnBorder int default '0',
                          btnBorderColor VARCHAR(7) default '#FFF',
                          btnBorderRadius int default '25',
                          btnMarginTop int default '10',
                          btnMarginBottom int default '20',
                          boxWidth int default '400',
                          boxPaddingSides int default '0',
                          boxPaddingTop int default '0',
                          boxPaddingBottom int default '20',
                          boxMarginSides int default '0',
                          boxMarginBottom int default '20',
                          boxAlign VARCHAR(5) default 'true',
                          boxMarginTop int default '0',
                          boxBgColor VARCHAR(7) default '#FFF',
                          boxBorder int default '0',
                          boxBorderColor VARCHAR(7) default '#F2F2F2',
                          boxBorderRadius int default '5',
                          titleColor VARCHAR(7) default '#495468',
                          titleFontSize int default '24',
                          titleLineHeight int default '36',
                          titleTextAlign VARCHAR(6) default 'center',
                          titleFontStyle VARCHAR(6) default 'normal',
                          titlePaddingSides int default '0',
                          titlePaddingTop int default '10',
                          titlePaddingBottom int default '10',
                          titleMarginTop int default '0',
                          titleMarginBottom int default '0',
                          titleBottomBorder int default '0',
                          titleBottomBorderColor VARCHAR(7) default '#EEEEEE',
                          dateTextAlign VARCHAR(6) default 'center',
                          datePaddingTop int default '10',
                          datePaddingBottom int default '10',
                          datePaddingSides int default '0',
                          dateMarginTop int default '0',
                          dateMarginBottom int default '0',
                          dateColor VARCHAR(7) default '#999999',
                          dateLableColor VARCHAR(7) default '#666666',
                          dateLableSize int default '12',
                          dateLabelLineHeight int default '16',
                          dateLabelStyle VARCHAR(6) default 'normal',
                          dateFontSize int default '14',
                          dateFontLineHeight int default '16',
                          dateFontStyle VARCHAR(6) default 'normal',
                          dateBorderColor VARCHAR(7) default '#EEEEEE',
                          dateBorderSize int default '1',
                          moreDateTextAlign VARCHAR(6) default 'center',
                          moreDateColor VARCHAR(7) default '#c4c4c4',
                          moreDateSize int default '12',
                          moreDateLineHeight int default '12',
                          moreDateMarginTop int default '10',
                          moreDateFontStyle VARCHAR(6) default 'normal',
                          moreDateHoverColor VARCHAR(7) default '#a3a3a3',
                          moreDateOn VARCHAR(5) default 'true',
                          moreDatePassed VARCHAR(5) default 'true',
                          moreDateUpcoming VARCHAR(5) default 'true',
                          moreDateTxt VARCHAR(100) default 'More Dates',
                          moreDateSectionMarginBottom VARCHAR(6) default '30',
                          modal_dateTitleTextAlign VARCHAR(6) default 'center',
                          modal_dateTitlePaddingSides int default '0',
                          modal_dateTitleMarginBottom int default '5',
                          modal_dateTitleColor VARCHAR(7) default '#000000',
                          modal_dateTitleFontSize int default '28',
                          modal_dateTitleFontLineHeight int default '30',
                          modal_dateTitleFontStyle VARCHAR(6) default 'italic',
                          modal_dateTextAlign VARCHAR(6) default 'left',
                          modal_datePaddingTop int default '0',
                          modal_datePaddingBottom int default '0',
                          modal_datePaddingSides int default '20',
                          modal_dateMarginTop int default '10',
                          modal_dateMarginBottom int default '10',
                          modal_dateColor VARCHAR(7) default '#999',
                          modal_dateLableColor VARCHAR(7) default '#f2f2f2',
                          modal_dateLableSize int default '12',
                          modal_dateLabelLineHeight int default '16',
                          modal_dateLabelStyle VARCHAR(6) default 'normal',
                          modal_dateFontSize int default '14',
                          modal_dateFontLineHeight int default '16',
                          modal_dateFontStyle VARCHAR(6) default 'normal',
                          detailsPaddingTop int default '10',
                          detailsPaddingBottom int default '10',
                          detailsPaddingSides int default '20',
                          detailsMarginTop int default '10',
                          detailsMarginBottom int default '0',
                          detailsColor VARCHAR(7) default '#999',
                          detailsLableColor VARCHAR(7) default '#CCC',
                          detailsLableSize int default '14',
                          detailsLabelLineHeight int default '32',
                          detailsLabelStyle VARCHAR(6) default 'normal',
                          detailsFontSize int default '32',
                          detailsFontLineHeight int default '32',
                          detailsFontStyle VARCHAR(6) default 'normal',
                          detailsBorderColor VARCHAR(7) default '#EEE',
                          detailsBorderSize int default '0',
                          detailsBorderSide int default '0',
                          infoMaxHeight int default '100',
                          infoExpandText VARCHAR(50) default 'more',

                          locationTextAlign VARCHAR(6) default 'left',
                          locationColor VARCHAR(7) default '#a5a5a5',
                          locationFontSize int default '12',
                          locationLineHeight int default '14',
                          locationFontStyle VARCHAR(6) default 'normal',

                          infoTextAlign VARCHAR(6) default 'left',
                          infoColor VARCHAR(7) default '#a5a5a5',
                          infoFontSize int default '12',
                          infoLineHeight int default '14',
                          infoFontStyle VARCHAR(6) default 'normal',
                          infoPaddingSides int default '10',
                          infoPaddingTop int default '10',
                          infoPaddingBottom int default '10',
                          infoMarginTop int default '0',
                          infoMarginBottom int default '0',
                          infoBorderColor VARCHAR(7) default '#eeeeee',
                          infoBorderSize int default '1',
                          modalMainColor VARCHAR(7) default '#2ecc71',
                          modalNameTxt VARCHAR(100) default 'Full Name',
                          modalEmailTxt VARCHAR(100) default 'Email Address',
                          modalPhoneTxt VARCHAR(100) default 'Phone Number',
                          modalAddressTxt VARCHAR(100) default 'Your Address',
                          modal_btnTxtColor VARCHAR(7) default '#FFF',
                          modal_btnFontSize int default '16',
                          modal_btnLineHeight int default '16',
                          modal_btnFontType VARCHAR(6) default 'normal',
                          modal_btnTopPadding int default '15',
                          modal_btnSidePadding int default '35',
                          modal_btnMarginTop int default '30',
                          modal_btnBorderRadius int default '6',
                          modal_titleSize int default '48',
                          modal_titleLineHeight int default '48',
                          modal_titleFontType VARCHAR(6) default 'normal',
                          modal_titleMarginBottom int default '40',
                          modal_input_fontSize int default '16',
                          modal_input_lineHeight int default '20',
                          modal_input_topPadding int default '12',
                          modal_input_space int default '10',
                          modalBookText VARCHAR(100) default 'Pay Later',
                          paypalBtnTxt VARCHAR(100) default 'Pay Now',
                          requirePhone VARCHAR(6) default 'true',
                          requireAddress VARCHAR(6) default 'true',
                          modal_txtColor VARCHAR(7) default '#FFF',
                          dateFormat VARCHAR(20) default 'F jS, Y',
                          timeFormat VARCHAR(20) default 'g:i A',
                          endsOnTxt VARCHAR(255) default 'Ends On:',
                          statsOnTxt VARCHAR(255) default 'Starts On:',
                          spotsLeftTxt VARCHAR(255) default 'left',
                          modalSpotsLeftTxt VARCHAR(255) default 'Spots left:',
                          modalQuantityTxt VARCHAR(255) default 'Quantity',
                          modalSingleCostTxt VARCHAR(255) default 'Single Cost',
                          modalTotalCostTxt VARCHAR(255) default 'Total Cost',
                          eventBookedTxt VARCHAR(255) default 'Event Booked!',
                          bookingTxt VARCHAR(255) default 'Booking Event ...',
                          ExpandTextTxt VARCHAR(255) default 'Expand',
                          closeTextTxt VARCHAR(255) default 'Close',
                          termsLink VARCHAR(255) default 'terms',
                          mapAddressType VARCHAR(20) default 'address',
                          mapAddress VARCHAR(255) default '',
                          mapZoom int default '16',
                          mapType VARCHAR(15) default 'ROADMAP',
                          modal_input_txtColor VARCHAR(7) default '#FFFFFF',
                          modal_inputHover_txtColor VARCHAR(7) default '#000000',
                          modal_input_bgColor VARCHAR(7) default '#FFFFFF',
                          modal_inputHover_bgColorHover VARCHAR(7) default '#FFFFFF',
                          modal_input_bgColorAlpha int default '20',
                          modal_inputHover_bgColorAlpha int default '60',
                          modal_selectHoverColor VARCHAR(7) default '#208F4F',
                          modal_selectTxtHoverColor VARCHAR(7) default '#FFFFFF',
                          currencyBefore VARCHAR(7) default 'true',
                          emailSubject VARCHAR(255) default 'Event Booking Information',
                          emailSSL VARCHAR(6) default 'false',
                          emailTemplate TEXT NOT NULL,
                          refundEmailTemplate TEXT NOT NULL,
                          refundOwnerEmailTemplate TEXT NOT NULL,
                          mapHeight int default '120',
                          checkBoxMarginBottom int default '20',
                          checkBoxMarginTop int default '20',
                          checkBoxTextColor VARCHAR(7) default '#EEE',
                          checkBoxColor VARCHAR(7) default '#111',
                          cal_height int default '400',
                          applyTxt VARCHAR(100) default 'Apply',
                          couponTxt VARCHAR(100) default 'Coupon',
                          freeTxt VARCHAR(100) default 'Free',
                          popupOverlayAlpha int default '100',
                          modalOverlayColor VARCHAR(7) default '#2ECC71',
                          return_same_page VARCHAR(7) default 'true',
                          return_page_url VARCHAR(255) default '',
                          infoNoButton VARCHAR(7) default 'true',
                          calEventDayColor VARCHAR(7) default '#FFFFFF',
                          calEventDayColorHover VARCHAR(7) default '#FFFFFF',
                          calTodayColor VARCHAR(7) default '#2eCC71',
                          calEventDayDotColorHover VARCHAR(7) default '#2ecc71',
                          calEventDayDotColor VARCHAR(7) default '#DDDDDD',
                          modal_includeTime VARCHAR(7) default 'false',
                          email_mode VARCHAR(7) default '3',
                          ticketsOrder int default '1',
                          permenantMoreButton VARCHAR(7) default 'false',
                          ownerEmailTemplate TEXT NOT NULL,
                          addToCalendar VARCHAR(7) default 'false',
                          addToCalendarText  VARCHAR(50) default '+GoogleCal',
                          addToCalendarTextColor VARCHAR(7) default '#ADADAD',
                          addToCalendarTextHoverColor VARCHAR(7) default '#CCC',
                          addToCalendarTextFontSize int default '12',
                          addToCalendarTextFontStyle VARCHAR(50) default 'italic',
                          addToCalendarMarginSide int default '5',
                          addToCalendarMarginBottom int default '5',
                          addToCalendarAlign VARCHAR(10) default 'left',
                          doAfterSuccess VARCHAR(15) default 'popup',
                          doAfterSuccessRedirectURL VARCHAR(255) default '',
                          doAfterSuccessTitle VARCHAR(255) default 'Success!',
                          doAfterSuccessMessage VARCHAR(255) default 'Thank you for reserving a spot. Looking forward to seeing you!',
                          priceDecimalCount int default '2',
                          priceDecPoint VARCHAR(2) default '.',
                          priceThousandsSep VARCHAR(2) default ',',
                          eventCardShowImage VARCHAR(7) default 'true',
                          eventDescriptionTitle VARCHAR(255) default 'Event Information',
                          infoTitleFontSize int default '18',
                          infoTitleColor VARCHAR(7) default '#111111',
                          cardDescriptionBackColor VARCHAR(7) default '#f1f1f1',
                          spotsLeftStrict VARCHAR(7) default 'false',
                          limitBookingPerEmail VARCHAR(7) default 'false',
                          limitBookingPerEmailCount int default '1',
                          bookingLimitText VARCHAR(255) default 'You have %left% tickets left!',
                          limitBookingPerTime VARCHAR(7) default 'false',
                          limitBookingPerTimeCount int default '1',
                          bookingLimitTimeText VARCHAR(255) default 'You can only book %left% time!',
                          showAllTickets VARCHAR(7) default 'false',
                          NoEventsInList VARCHAR(255) default 'No current events.',

                          passedOccurencesText VARCHAR(255) default 'Passed Dates:',
                          upcomingOccurencesText VARCHAR(255) default 'Upcoming Dates:',

                          eventsListFilterColor VARCHAR(7) default '#1abc9c',
                          eventsListFilterTextColor VARCHAR(7) default '#FFFFFF',
                          eventsListFilterBorderRadius int default '4',
                          eventsListFilterFontSize int default '16',
                          eventsListFilterPaddingSides int default '13',
                          eventsListFilterPaddingVertical int default '8',
                          eventsListFilterLable VARCHAR(100) default 'Show All',

                          eventCardShowThumbnail VARCHAR(7) default 'true',
                          eventCardExpandThumbnailWidth varchar(4) default '15%',
                          eventCardThumbnailWidth varchar(4) default '35%',

                          eventCardImageAsBackground VARCHAR(7) default 'false',
                          calendarImageAsBackground VARCHAR(7) default 'false',

                          sendEmailToAdmin VARCHAR(7) default 'true',
                          sendEmailToCustomer VARCHAR(7) default 'true',

                          cal_hasBoxShadow VARCHAR(7) default 'false',
                          box_hasBoxShadow VARCHAR(7) default 'false',

                          PRIMARY KEY (id)
            );";

      dbDelta($categories_sql);
      dbDelta($categoryEvents_sql);
      dbDelta($coupon_sql);
      dbDelta($couponsUsed_sql);
      dbDelta($events_sql);
      dbDelta($occurTable_sql);
      dbDelta($ticketsTable_sql);
      dbDelta($eventCouponsTable_sql);
      dbDelta($payments_sql);
      dbDelta($settings_sql);
      dbDelta($gatewaysTable_sql);

    if (!get_option("ebp_version")) {

      $defaultTemplate = addslashes($this->getDefaultEmailTemplate());
      $refundEmailTemplate = 'A refund was issued fot $eventname% booking!';
      $refundOwnerEmailTemplate = 'A refund was issued to %payer_name%(%payer_email%) on booking no %paymentID%';

      $defaultSettings = array('id'=> '1', "emailMsg"=> "Dont Be late","emailTemplate"=> $defaultTemplate,
            "refundEmailTemplate"=> $refundEmailTemplate, 'refundOwnerEmailTemplate'=> $refundOwnerEmailTemplate);

      $defaultSettings2 = array('id'=> '2', "emailMsg"=> "Dont Be late","boxAlign"=> "false","emailTemplate"=> $defaultTemplate,
          "refundEmailTemplate"=> $refundEmailTemplate, 'refundOwnerEmailTemplate'=> $refundOwnerEmailTemplate);

      $defaultSettings3 = array('id'=> '3', 'includeEndsOn' => 'false', "emailMsg"=> "Dont Be late","emailTemplate"=> $defaultTemplate,
              "refundEmailTemplate"=> $refundEmailTemplate, 'refundOwnerEmailTemplate'=> $refundOwnerEmailTemplate);

      $wpdb->insert($settingsTable, $defaultSettings);
      $wpdb->insert($settingsTable, $defaultSettings2);
      $wpdb->insert($settingsTable, $defaultSettings3);
    }

    $currVersion = floatval(get_option("ebp_version"));

    if ($currVersion < 3.02) {
      $this->fixDateFormats();
      $this->updateDefaultEmailTemplate();
    }

    if ($currVersion < 3.2) {
      //change emailSSL from true to SSL
      $emailSSL = $wpdb->get_var( "select emailSSL from " . $settingsTable ." where id= '1'");
      if ($emailSSL == "true")
        $wpdb->update($settingsTable, array('emailSSL'=> 'ssl'), array("id"=> '1'));

      $emailSSL2 = $wpdb->get_var( "select emailSSL from " . $settingsTable ." where id= '2'");
      if ($emailSSL2== "true")
        $wpdb->update($settingsTable, array('emailSSL'=> 'ssl'), array("id"=> '2'));
    }

    if ($currVersion < 3.33) {
      //style fix
      //box
      $settings = $wpdb->get_row( "SELECT * FROM " . EventBookingHelpers::getTableName("settings")." where id= '1' ");
      $wpdb->update(EventBookingHelpers::getTableName("settings"), array("btnMarginBottom"=> $settings->boxPaddingBottom), array("id"=> "1"));
      $wpdb->update(EventBookingHelpers::getTableName("settings"), array("boxPaddingBottom"=> '0'), array("id"=> "1"));
      //cal
      $settingsCal = $wpdb->get_row( "SELECT * FROM " . EventBookingHelpers::getTableName("settings")." where id= '2' ");
      $wpdb->update(EventBookingHelpers::getTableName("settings"), array("btnMarginBottom"=> $settingsCal->boxPaddingBottom), array("id"=> "2"));
      $wpdb->update(EventBookingHelpers::getTableName("settings"), array("boxPaddingBottom"=> '0'), array("id"=> "2"));
      update_option('ebp_styleMigrate', 1);

      $defaultOwnerTemplate=addslashes($this->getDefaultOwnerEmailTemplate());
      $wpdb->update($settingsTable, array("ownerEmailTemplate"=> $defaultOwnerTemplate), array("id"=> "1"));
      $wpdb->update($settingsTable, array("ownerEmailTemplate"=> $defaultOwnerTemplate), array("id"=> "2"));

    }

    $settings_count = $wpdb->get_var( "select  COUNT(*)  from ". $settingsTable);

    if ($settings_count < 3) {
      $defaultSettings3 = $wpdb->get_row( "SELECT * FROM " . $settingsTable." where id= '1' ", ARRAY_A);
      $defaultSettings3["id"] = 3;
      $wpdb->insert($settingsTable, $defaultSettings3 );
    }

    if ($currVersion < 3.38) {
      $wpdb->query("ALTER  TABLE " . $couponsTable ." MODIFY  amount VARCHAR(40)");
      $wpdb->update($settingsTable,EventCard::getDefaultSettings(), array("id"=> "3"));
    }

    update_option("ebp_version", $this->version);
  }


  function updateDefaultEmailTemplate() {
    global $wpdb;
    $defaultTemplate = addslashes($this->getDefaultEmailTemplate());
    $wpdb->update(EventBookingHelpers::getTableName("settings"), array("emailTemplate"=> $defaultTemplate), array("id"=> "1"));
    $wpdb->update(EventBookingHelpers::getTableName("settings"), array("emailTemplate"=> $defaultTemplate), array("id"=> "2"));

    return;
  }

  function fixDateFormats() {
    global $wpdb;

    $table_name = EventBookingHelpers::getTableName("eventDates");

    $wpdb->query("ALTER  TABLE " . $table_name ." MODIFY  end_date VARCHAR(20)");
    $wpdb->query("ALTER  TABLE " . $table_name ." MODIFY  start_date VARCHAR(20)");

    $results = $wpdb->get_results( "SELECT * FROM " . $table_name);

    foreach( $results as $result ) {
      $date_s = new DateTime($result->start_date);
      $startDate = $date_s->format('Y-m-d');

      $date_e = new DateTime($result->end_date);
      $endDate = $date_e->format('Y-m-d');

      $wpdb->update($table_name, array('start_date'=> $startDate, 'end_date'=> $endDate), array("id"=> $result->id));
    }

  }

  function fixMobileBookingPage() {
    delete_option("ebp_page_title");
    add_option("ebp_page_title", $this->mobileBookingPage_title, '','yes');

    delete_option("ebp_page_name");
    add_option("ebp_page_name", $this->mobileBookingPage_name, '','yes');

    // Create post object
    $_p = array();
    $_p['post_title'] = $this->mobileBookingPage_title;
    $_p['post_content'] = $this->mobileBookingPage_desc;
    $_p['post_status'] = 'publish';
    $_p['post_type'] = 'page';
    $_p['comment_status'] = 'closed';
    $_p['ping_status'] = 'closed';
    $_p['post_category'] = array(1); // the default 'Uncatrgorised'

    // Insert the post into the database
    $mobileBookingPage_id = wp_insert_post( $_p );


    delete_option('ebp_page_id');
    add_option( 'ebp_page_id', $mobileBookingPage_id );
  }

  function admin_menu() {
    $mainMenu = add_menu_page('Events (EBP)','Events (EBP)','manage_options','eventManagement', array(&$this, 'admin_page'),$this->url."/images/icon.png");
    add_action('load-'.$mainMenu, array(&$this, 'admin_menu_scripts'));
    add_action('load-'.$mainMenu, array(&$this, 'admin_menu_styles'));
  }

  function admin_menu_scripts() {
  //  wp_enqueue_script('ebp-underscore-js', $this->url . 'adminjs/underscore-min.js');

    wp_enqueue_script('underscore');
    wp_enqueue_script('ebp-tinymce-js', $this->url . 'adminjs/tinymce/tinymce.min.js', array('jquery') );
    wp_enqueue_script('ebp-table2CSV-js', $this->url . 'adminjs/table2CSV.min.js', array('jquery') );
    wp_enqueue_script('ebp-bootstrap-switch-js', $this->url . 'adminjs/bootstrap-switch.js' );
    wp_enqueue_script('ebp-ebpTimePicker-js', $this->url . 'adminjs/ebpTimePicker.js' );
    wp_enqueue_script('ebp-jquery-dynatable', $this->url . 'adminjs/jquery.dynatable.js', array('jquery') );

    wp_enqueue_media();
    wp_enqueue_script('jquery-ui-datepicker');
    wp_enqueue_script('wp-color-picker');
    wp_enqueue_script('thickbox');
    wp_enqueue_script('media-upload');
    wp_enqueue_script('ebp-uploader', $this->url . 'adminjs/uploader.js', array('thickbox','media-upload' ), array('jquery')  );
    wp_enqueue_script('ebp-modernizr-js', $this->url . 'adminjs/modernizr.custom.53451.js' );
    wp_enqueue_script('ebp-jquery-dropDown', $this->url . 'adminjs/jquery.dropdown.min.js' );

    wp_enqueue_script('ebp-admin-js', $this->url . 'adminjs/admin.'.$this->minified.'js', array('jquery') );

  }

  function admin_menu_styles() {
    wp_enqueue_style( 'thickbox' );
    wp_enqueue_style('wp-color-picker');
    wp_enqueue_style( 'ebp-admin-css', $this->url . 'css/admin.css' );
    wp_enqueue_style( 'jquery-ui-datepicker','http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.18/themes/smoothness/jquery-ui.css');
  }

  function frontEndStyle() {
    wp_enqueue_style( 'ebp_style', plugins_url( '/css/frontend.css', __FILE__ ), array(), '20142209','all' );
    wp_enqueue_script('ebp-helpers-js', $this->url . 'js/helpers.js', array('jquery'), '20142209',true );
    wp_enqueue_script('ebp-helpers-dropdown-js', $this->url . 'js/jquery.dropdown.js', array( 'jquery','ebp-helpers-js' ), '20142209', true);
    wp_enqueue_script('ebp-jquery-ebpFullCalendar', $this->url . 'js/jquery.ebpFullCalendar.js', array( 'jquery','ebp-helpers-js' ), '20142209', true);
    wp_enqueue_script('ebp-gmap-js', "https://maps.googleapis.com/maps/api/js?v=3.exp&sensor=false");
    wp_enqueue_script('ebp-frontend-js', $this->url . 'js/frontend.'.$this->minified.'js', array('jquery', 'ebp-gmap-js','ebp-helpers-js'), '20142209', true);
  }

  function getDayEvents() {
    global $wpdb;
    $currentDay = $_POST['currentDay'];
    $categories = $_POST['categories'];
    $width = intval($_POST['width']);
    $eventsData = $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("events"));
    $settingsOption = EventBookingHelpers::getStyling($width,1);
    $modals = '';
    $eventOrder = array();

    foreach($eventsData as $eventData ) {
      $id = $eventData->id;
      if (EventBookingHelpers::eventBelongsToCategoreis($id,$categories)) {
        $calSQL = "SELECT * FROM " . EventBookingHelpers::getTableName("eventDates")." where event= '$id' && start_date= '$currentDay'";

        $occurences = $wpdb->get_results($calSQL);
        foreach($occurences as $occur ) {
          $date = new DateTime($occur->start_date);
          $eventDate = $date->format('m-d-Y');

          $sortDate = $date->format('Ymd');

          $markUp = $this->getEventMarkUp($id,$occur->id,$eventData,$settingsOption);
          $modals .= $markUp["modal"];

          $data = '<div class= "eventDisplayCnt"  style="'.$settingsOption["box"].'" data-init-width="'.$width.'">';
          $data .= $markUp["html"];
          $data .= '</div>';

          $eventOrder[$sortDate.$occur->start_time.$occur->id]= $data;
        }
      }
    }

    ksort($eventOrder);
    $data = '';
    foreach ($eventOrder as $key=> $val)
      $data .= $val;

    exit($data.$modals);
  }


  function getCalData() {
    global $wpdb;

    $nextMonth = sprintf('%02d',intval($_POST['month'])+1);
    $month = sprintf('%02d',$_POST['month']);
    $year = sprintf('%04d',$_POST['year']);
    $width = intval($_POST['width']);
    $categories = $_POST['categories'];
    $type = $_POST['type'];


    $nextMnthDate = date($year.'-'.$nextMonth.'-01');
    $prevMnthDate = date($year.'-'.$month.'-01');
    $eventsData = $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("events"));


    $eventsData = $wpdb->get_results("SELECT *, o.id as date_id FROM ".EventBookingHelpers::getTableName("events")." as e right OUTER join ".EventBookingHelpers::getTableName("eventDates")."  as o on e.id = o.event where o.start_date<'$nextMnthDate' && o.start_date>= '$prevMnthDate' order by o.start_date asc, o.start_time asc");

    $settingsOption = EventBookingHelpers::getStyling($width, 2);
    $modals = '';
    $data = array();


    foreach ($eventsData as $occur) {
      $id = $occur->event;
      if (Event::eventBelongsToCategories($id,$categories)) {

        $date = new DateTime($occur->start_date);
        $eventDate = $date->format('m-d-Y');

        if ($type == 'hasevent') {
          $data[$eventDate] = 'eventname';
        } else {
          $markUp = $this->getEventMarkUp($id,$occur->date_id, $occur, $settingsOption);
          $modals .= $markUp["modal"];

          $markUpHtml = '';
          if ($settingsOption["settings"]->calendarImageAsBackground == 'true' && $occur->background) {
            $bgImageArr = explode('__and__', $occur->background);
            $markUpHtml .= '<input type="hidden" name="bgImage" value="'.$bgImageArr[sizeof($bgImageArr) -1].'" />';
          }
          $markUpHtml .= $markUp["html"];

          if (array_key_exists($eventDate, $data))
            $data[$eventDate] .= $markUpHtml;
          else
            $data[$eventDate] = $markUpHtml;
        }

      }
    }

    if ($type == 'hasevent') {
      echo json_encode($data);
    } else {
      $bothData["modals"] = $modals;
      $bothData["data"] = $data;
      echo json_encode($bothData);
    }

    exit();
  }

  function calendarShortcode($atts, $content = NULL) {
     extract(shortcode_atts( array('width'=> NULL, 'categories'=> NULL, 'height'=> NULL,
      'loadall'=> "false", 'tooltip'=> "on", 'show_events_directly'=> 'off'), $atts ) );

     if ($show_events_directly == 'on')  $tooltip = 'off';

     global $wpdb;

     $settingsOption = EventBookingHelpers::getStyling($width, 2);
     $modals = '';

     $html = '<div class= "eventDisplayCnt isCalendar">';
     $html .= '<style>
        .fc-calendar .fc-head,
        .eventDisplayCnt .custom-header nav span:before {color: '.$settingsOption["calColor"].';}
        .eventDisplayCnt .eventContent span.eventClose,
        .fc-calendar .fc-row > div.fc-today {background-color: '.$settingsOption["calColor"].'; border: 1px solid '.$settingsOption["calColor"].';}
        .eventDisplayCnt .eventContent h4 {border-top: '.$settingsOption["calCloseStyle"].';}
        .fc-calendar-container,
        .eventDisplayCnt .eventContent,
        .custom-inner:after {background-color: '.$settingsOption["cal_bgColor"].';}
        .fc-calendar .fc-row > div.fc-content{background: '.$settingsOption["settings"]->calEventDayColor.';}
        .fc-calendar .fc-row > div.fc-content:hover{background: '.$settingsOption["settings"]->calEventDayColorHover.';}
        .fc-calendar .fc-row > div.fc-content:after{color: '.$settingsOption["settings"]->calEventDayDotColor.';}
        .fc-calendar .fc-row > div.fc-content:hover:after{color: '.$settingsOption["settings"]->calEventDayDotColorHover.';}
        .fc-calendar .fc-row > div.fc-content:not(.noToolTip):before {background: '.$settingsOption["settings"]->calEventDayDotColorHover.';}
        .showEventsDirectly .fc-calendar .fc-row > div.fc-content:before {background: '.$settingsOption["settings"]->calEventDayDotColorHover.';}
        .showEventsDirectly .fc-calendar .fc-row > div > span.fc-date  {background: '.$settingsOption["settings"]->calEventDayColor.';}
        .fc-calendar .fc-row > div.fc-today span.fc-date{background-color: transparent !important;}
        .fc-calendar .fc-row > div.fc-today {background-color: '.$settingsOption["settings"]->calTodayColor.';}
        .fc-calendar .fc-row > div.fc-today:hover{background-color: '.$settingsOption["settings"]->calTodayColor.';}';

     $calheight = ($height == NULL) ? $settingsOption["settings"]->cal_height : $height;

     $html .= '.fc-calendar-container {height: '.$calheight.'px;}';

     $html .= '.eventDisplayCnt .eventContent h4 ,.eventDisplayCnt .custom-header {background-color: '.$settingsOption["cal_titleBgColor"].';}
        .fc-calendar .fc-row > div > span.fc-date {color:'.$settingsOption["cal_dateColor"].'}
        .fc-calendar .fc-row > div{background:'.$settingsOption["cal_boxColor"].'}
        .eventDisplayCnt .eventContent{'.$settingsOption["eventContentStyling"].'}
        '.EventBookingHelpers::getLoaderStyle($settingsOption["calColor"], "#FFF").'
      </style>';

      $calendarModeClass = ($show_events_directly == 'on') ? ' showEventsDirectly' : '';
      $html .= '<section class= "calInstance '.$calendarModeClass.'" style="'.$settingsOption["calStyle"].'">';
      $html .= '<input name= "ajaxlink" value="'.site_url().'" type= "hidden"  />';
      $html .= '<div class= "custom-calendar-wrap">';

      $calendarHasBoxShadow =  ($settingsOption["settings"]->cal_hasBoxShadow == 'true') ? ' hasBoxShadow' : '';

        $html .= '<div  class= "custom-inner '. $calendarHasBoxShadow.'" style="'.$settingsOption["calBodyStyle"].'">';
          $html .= '<div class= "custom-header clearfix" >';
            $html .= '<nav>';
              $html .= '<span id= "custom-prev" class= "custom-prev"></span>';
              $html .= '<span id= "custom-next" class= "custom-next"></span>';
            $html .= '</nav>';
            $html .= '<h2 id= "custom-month" class= "custom-month"></h2>';
            $html .= '<h3 id= "custom-year" class= "custom-year"></h3>';
          $html .= '</div>';
          $html .= '<div id= "calendar" class= "fc-calendar-container"  data-allLoaded="'.$loadall.'" data-categories="'.$categories.'" data-init-width="'.$settingsOption['width'].'" data-startIn="'.$settingsOption["startIn"].'" data-displayMonthAbbr="'.$settingsOption["displayMonthAbbr"].'" data-displayWeekAbbr="'.$settingsOption["displayWeekAbbr"].'" data-tooltip="'.$tooltip.'" data-background="'.$settingsOption["settings"]->calendarImageAsBackground.'">';

          $html .= '<ul class= "eventlist" style= "display:none">';

          $nextMnthDate = date('Y-m-01', strtotime('+1 month'));
          $prevMnthDate = date('Y-m-01');
          $occurences = $wpdb->get_results("SELECT *, o.id as date_id  FROM ".EventBookingHelpers::getTableName("events")." as e right OUTER join ".EventBookingHelpers::getTableName("eventDates")." as o on e.id = o.event where o.start_date<'$nextMnthDate' && o.start_date>= '$prevMnthDate' order by o.start_date asc, o.start_time asc");

            foreach ($occurences as $occur) {
              $id = $occur->event;

              if (!Event::eventBelongsToCategories($id, $categories)) continue;

              $date = new DateTime($occur->start_date);
              $eventDate = $date->format('m-d-Y');
              $html .= '<li data-date="'.$eventDate.'">';

                if ($occur->background) {
                  $bgImageArr =  explode('__and__', $occur->background);
                  $html .= '<input type="hidden" name="bgImage" value="'.$bgImageArr[sizeof($bgImageArr) -1].'" />';
                }


                $markUp = $this->getEventMarkUp($id, $occur->id, $occur, $settingsOption);
                $html .= $markUp["html"];
                $modals.= $markUp["modal"];

              $html .= '</li>';
            }


              $html .= '</ul>';
              $html .= '<div class= "calendarBlocker"><div id= "fountainG"><div id= "fountainG_1" class= "fountainG"></div><div id= "fountainG_2" class= "fountainG"></div><div id= "fountainG_3" class= "fountainG"></div><div id= "fountainG_4" class= "fountainG"></div><div id= "fountainG_5" class= "fountainG"></div><div id= "fountainG_6" class= "fountainG"></div><div id= "fountainG_7" class= "fountainG"></div><div id= "fountainG_8" class= "fountainG"></div></div></div>';
            $html .= '</div>';
          $html .= '</div>';
        $html .= '</div>';
      $html .= '</section>';
      $html .= $modals;
      $html .= '</div>';
    return $html;
  }

  function eventsListShotcode($atts, $content = NULL) {
    extract( shortcode_atts( array('events'=> 'all', 'order'=> 'asc','type'=> 'box','categories'=>NULL,
      'limit'=> 100, 'width'=> NULL, 'months'=> NULL ,'nextdays'=>NULL, 'filter'=>'off'), $atts));

    global $wpdb;

    $settingsOption = EventBookingHelpers::getStyling($width, 1);

    $eventsListHtml = self::getEventListData($settingsOption, $events, $order, $type, $categories, $limit, $width, $months, $nextdays);

    $finalHtml = '';

    if ($eventsListHtml == '') {
      $finalHtml = $settingsOption["settings"]->NoEventsInList;
    } else {
      $finalHtml = Event::getFilterStyle($settingsOption["settings"]).'<div class="eventsGroup">';
        if ($filter == 'on') {
          $finalHtml .= Event::getUsedCategoriesAsFilters($categories, $settingsOption["settings"]);
        }

        $finalHtml .= $eventsListHtml;
      $finalHtml .= '</div>';
    }

    return $finalHtml;
  }

  function getEventListData ($settingsOption, $events, $order, $type, $categories, $limit, $width, $months, $nextdays) {
    global $wpdb;
    $finalHtml = '';

    $COND = '';
    switch ($events) {
      case 'passed':
        $COND = 'where start_date < CURDATE() or (start_date = CURDATE() and start_time <= CURTIME())';
        break;
      case 'all':
        $COND = '';
        break;
      default:
        $COND = 'where o.start_date > CURDATE() or (o.start_date = CURDATE() and o.start_time > CURTIME()) or o.endBooking_date > CURDATE() or (o.endBooking_date = CURDATE() and o.endBooking_time > CURTIME())';
        break;
    }

    $results = $wpdb->get_results("SELECT *, o.id as date_id FROM ".EventBookingHelpers::getTableName("events")." as e right OUTER join ".EventBookingHelpers::getTableName("eventDates")."  as o on e.id = o.event ".$COND." order by o.start_date ".$order.", o.start_time  ".$order. " limit ".$limit);

    $addedEvents = array();

    foreach ($results as $result) {
      $id = $result->event;

      if (in_array($id, $addedEvents)) {
        continue;
      }

      $inMonths = false;
      $isNextdays = false;


      $inMonths = $inMonths || Event::eventBelongsToMonths($result->start_date, $months);
      $isNextdays = $isNextdays || Event::eventBelongsToNextDays($result->start_date, $nextdays);


      if (Event::eventBelongsToCategories($id, $categories) && $inMonths && $isNextdays) {
        array_push($addedEvents, $id);

        if ($type == "card") {
          $htmlTemp = EventCard::getCard($id, $result->date_id, $width);
        } else if ($type == "cardExpand") {
          $htmlTemp = EventCardExtended::getCard($id, $result->date_id, $width);
        } else {
          $htmlTemp = '<div class= "eventDisplayCnt" data-init-width="'.$settingsOption['width'].'" style="'.$settingsOption["box"].'">';
            $markUp = $this->getEventMarkUp($id, $result->date_id, $result, $settingsOption);
            $htmlTemp .= $markUp["html"];
            $htmlTemp .= $markUp["modal"];
          $htmlTemp .= '</div>';
        }

        $finalHtml .= $htmlTemp;
      }

    }

    return $finalHtml;
  }


  function eventButtonShortCode($atts, $content = NULL) {
    $settingsOption = EventBookingHelpers::getStyling(NULL,1);
    $btnStyling = $settingsOption["btn"];

     extract( shortcode_atts( array('id'=> '1','date_id'=> -1, 'include_price'=> $settingsOption["showPrice"] ), $atts ) );

    global $wpdb;
    $result = $wpdb->get_row( "SELECT * FROM " . EventBookingHelpers::getTableName("events")." where id= '$id' ");

    $curSymbol= EventBookingHelpers::getSymbol($settingsOption["currency"]);


    if ($result != NULL) {
      //get cost
      $eventTickets = $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("tickets")." where event= '$id' order by id asc");
      $i=0;
      foreach($eventTickets as $eventData) {
        if (  $i == 0) {
          $ticketID = $eventData->id;
          $cost = $eventData->cost;
          break;
        }
      }

      $isBooked = true;
      $today = current_time('Y-m-d');

      $p = 0;
      $dateId = $date_id;
      if ($date_id < 0) {
        $upcomingDates = $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("eventDates")." where event='$id' and  start_date>= '$today' order by start_date asc");
        foreach($upcomingDates as $dateRow) {
          if (Event::occurenceHasPassed($dateRow)) continue;

          $p++;
          if ($p == 1) {
            $eventDateObj = $dateRow;
            $dateId = $dateRow->id;
          }

          //get booked
          foreach($eventTickets  as $ticketInfo) {
            if (Event::checkSpots($dateRow->id,$ticketInfo->id)>0) {
              $isBooked=false;
              break;
            }
          }
        }
        if ($p == 0) $eventDateObj = false;
      } else {
        $eventDateResult = $wpdb->get_row( "SELECT * FROM " . EventBookingHelpers::getTableName("eventDates")." where id= '$date_id'");
        $eventDateObj = $eventDateResult;
        $dateId = $date_id;
        foreach($eventTickets  as $ticketInfo) {
          $p ++;
          if (Event::checkSpots($date_id,$ticketInfo->id) > 0) {
            $isBooked = false;
            break;
          }
        }
      }

      $today = current_time('Y-m-d');

      if ($content == NULL )
        $txt = $result->name;
      else
        $txt = $content;

      $active = true;
      $price = '';

      if (Event::occurenceHasPassed($eventDateObj) || $p == 0) {
        $price = ' <span> - '.$settingsOption["passedTxt"].'</span>';
        $active = false;
      } else if ($isBooked) {
        $price = ' <span> - '.$settingsOption["bookedTxt"].'</span>';
        $active = false;
      } else {
        // will show button.
        if ($include_price == "true") {
          $price = ' <span>(';

          $price .= EventBookingHelpers::currencyPricingFormat($cost, $curSymbol,
            $settingsOption["settings"]->currencyBefore, $settingsOption["settings"]->priceDecimalCount,
            $settingsOption["settings"]->priceDecPoint,$settingsOption["settings"]->priceThousandsSep);

          $price .=')</span>';
        }
      }

      $html = '<div class= "eventBtnCnt">';
      $html .= '<div class= "eb_frontend">';
      $html .= EventBookingHelpers::getModalStyles($settingsOption["settings"]);

      $bookingBtn = Event::getModalBtn($id, $eventDateObj, $dateId, $dateId, $active, $btnStyling,
        $txt.$price, $settingsOption["settings"]->bookingStartsTxts, $settingsOption["settings"]->bookingEndedTxt, $settingsOption["dateFormat"], $settingsOption["timeFormat"]);
      $html .= $bookingBtn['html'] . $bookingBtn['modal'];
      //
      if ($active) $html .= Event::getBookModal($id,$dateId,$ticketID,$result);

      $html .= '</div>';
      $html .= '</div>';

    } else {
       $html = '<div class= "eventNotFound">Event Not Found!</div>';
    }
    return $html;
  }

  function eventCardShortCode($atts, $content = NULL) {
    extract( shortcode_atts( array('id'=> '1','date_id'=> -1, 'width'=> NULL, 'expand'=> 'on'), $atts ) );

    if ($expand == "off")
      $html = EventCard::getCard($id, $date_id, $width);
    else
      $html = EventCardExtended::getCard($id, $date_id, $width);

    return $html;
  }

  function eventBoxShortCode($atts, $content = NULL) {
    extract( shortcode_atts( array('id'=> '1','date_id'=> -1, 'show_all_tickets'=>NULL, 'width'=> NULL), $atts ) );

    global $wpdb;

    $result = $wpdb->get_row( "SELECT * FROM " . EventBookingHelpers::getTableName("events")." where id= '$id' ");
    $settingsOption = EventBookingHelpers::getStyling($width,1);

    if ($show_all_tickets != NULL) {
      $settingsOption["settings"]->showAllTickets = $show_all_tickets;
    }

    if ($result != NULL) {
      $html = '<div class= "eventDisplayCnt"   data-init-width="'.$settingsOption['width'].'" style="'.$settingsOption["box"].'">';
      $markUp = $this->getEventMarkUp($id, $date_id, $result, $settingsOption);
      $html .= $markUp["html"];
      $html .= $markUp["modal"];
      $html .= '</div>';
    } else {
      $html = '<div class= "eventNotFound" style= "width:auto;">Event Not Found!</div>';
    }
    return $html;
  }


  function getEventMarkUp($id, $dateId, $data, $settingsOption) {
    global $wpdb;

    $date_id= $dateId;

    $curSymbol = EventBookingHelpers::getSymbol($settingsOption["currency"]);

    $eventClasses = Event::eventIdentificationClasses($id);

     //styles
    $html = EventBookingHelpers::getModalStyles($settingsOption["settings"]);
    $html .= '<style>';
        $html .= '.eventDisplayCnt:not(.isCalendar) .info a.expand{'.$settingsOption["moreDareBtn"].'}';
        $html .= '.eb_frontend  .info a.expand {color: '.$settingsOption["infoColor"].'; margin-left: -'.$settingsOption["infoPaddingSides"].'px;}';
        $html .= '.ebp_btn_people,.ebp_btn_people:hover{color:'.$settingsOption['settings']->btnBgColor.';}';
    $html .= '</style>';

    $boxHasBoxShadow =  ($settingsOption["settings"]->box_hasBoxShadow == 'true') ? ' hasBoxShadow' : '';

    //title
    $html .= '<div class= "eb_frontend '.$eventClasses.$boxHasBoxShadow.' ">';
    $html .= '<div class= "name" style= "display:none;" >'.stripslashes($data->name).'</div>';
    $html .= '<h3 class= "title" style="'.$settingsOption["title"].'">'.stripslashes($data->name).'</h3>';

    //image
    if ($data->image!= "")
        $html .= '<div class= "eventImage" style="'.$settingsOption["imageStyle"].'" data-image="'.$data->image.'" data-image-crop="'.$settingsOption["imageCrop"].'" data-image-height="'.$settingsOption["imageHeight"].'"  data-image-width="'.$settingsOption["imgWidth"].'" ></div>';

    //map
    $html .= '<div class= "map_canvas" style= "display:none; height:'.$settingsOption["settings"]->mapHeight.'px;" data-address="'.$data->mapAddress.'" data-zoom="'.$data->mapZoom.'" data-maptype="'.$data->mapType.'" data-addressType="'.$data->mapAddressType.'" ></div>';

    //info
    if ($data->info != "") {
      $infoDeactive = ($settingsOption["settings"]->infoNoButton == "true") ? '' : 'deactive';
      $html .= '<div class= "info '.$infoDeactive.'" style="'.$settingsOption["info"].'" data-closeTxt="'.$settingsOption["closeTextTxt"].'" data-expandTxt="'.$settingsOption["ExpandTextTxt"].'" data-height="'.$settingsOption["infoHeight"].'">';
          $html .= '<div class= "cnt">';
              $html .=stripslashes ($data->info);
          $html .= '</div>';
      $html .= '</div>';
    }

    //get date
    $today = current_time('Y-m-d');
    $passedDates = $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("eventDates")." where event= '$id' and  start_date<= '$today' order by start_date desc, start_time asc");
    $upcomingDates = $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("eventDates")." where event= '$id' and  start_date>= '$today' order by start_date asc, start_time asc");

    $allDates = array_merge($passedDates, $upcomingDates);

    $dateMarkUp = Event::getEventDateMarkUp($data, $dateId, $settingsOption, $upcomingDates, $passedDates);

    $html .= $dateMarkUp["html"];
    $date_id = $dateMarkUp["dateID"];
    $date = $dateMarkUp["date"];
    $start_time = $dateMarkUp["start_time"];
    $occurrence = $dateMarkUp["occurrence"];
    //details
    $eventTickets = $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("tickets")." where event='$id' order by id asc");


    $ticketID = $eventTickets[0]->id;
    $cost = $eventTickets[0]->cost;

    if ($settingsOption["settings"]->showAllTickets == 'false') {
      $left = 0;
      foreach($eventTickets as $ticketInfo) {
        $left += Event::checkSpots($date_id, $ticketInfo->id);
      }

      $bookingsAll = $wpdb->get_results("SELECT * FROM " . EventBookingHelpers::getTableName("payments")." where date_id='$date_id' and event_id='$id'");
      $spotsBookedAll = 0;
      foreach($bookingsAll as $bookingA) {
        if ($settingsOption["settings"]->spotsLeftStrict == "false") {
           $spotsBookedAll += intval($bookingA->quantity);
        } else {
          $bookingStatus = $bookingA->status;
          if ( strcasecmp($bookingStatus, "paid") == 0 || strcasecmp($bookingStatus, "ok")==0 ||
           strcasecmp($bookingStatus, "not paid") == 0 || strcasecmp($bookingStatus, "completed")== 0 ||
          strcasecmp($bookingStatus, "success") == 0 || strcasecmp($bookingStatus, "successful")== 0
          || strcasecmp($bookingStatus, "successfull") == 0 )
              $spotsBookedAll += intval($bookingA->quantity);
        }
      }

      $maxSpots = intval($data->maxSpots);

      $left = ($maxSpots > 0) ? ($maxSpots - $spotsBookedAll) : $left;

      if ($left < 0) $left = 0; // take into account forced bookings

      if ($data->showPrice == "true" || $data->showSpots == "true") {
        $html .= '<div class= "eventDetails" style="'.$settingsOption["details"].'">';

        if ($data->showPrice == "true") {
          if (floatval($cost) == 0) {
              $html .= '<div class= "price" style="'.$settingsOption["costStyle"].'">'.$settingsOption["settings"]->freeTxt.'</div>';
          } else if ($data->showPrice == "true") {
            $html .= '<div class= "price" style="'.$settingsOption["costStyle"].'">';

            $html .=  EventBookingHelpers::currencyPricingFormat($cost,$curSymbol,$settingsOption["settings"]->currencyBefore,$settingsOption["settings"]->priceDecimalCount,$settingsOption["settings"]->priceDecPoint,$settingsOption["settings"]->priceThousandsSep);

            $html .= '</div>';
          }
        }

        if ($data->showSpots == "true") {
          $occurPassed = Event::occurenceHasPassed($occurrence) ;
          if ($occurPassed || (!$occurPassed && Event::bookingOpen($occurrence) > 1)) {
            $html .= '<div class= "passedEvent" style= "font-size:0.6em;'.$settingsOption["spotsStyle"].'">'.$settingsOption["passedTxt"].'</div>';
          } else {
            if ($left == 0) {
              $html .= '<div class= "passedEvent" style= "font-size:0.6em;'.$settingsOption["spotsStyle"].'">'.$settingsOption["bookedTxt"].'</div>';
            } else {
              $html .= '<div class= "spots" style="'.$settingsOption["spotsStyle"].'">'.$left.'<span style="'.$settingsOption["detailsLabel"].'">'.$settingsOption["spotsLeftTxt"].'</span></div>';
            }
          }
        }

        $html .= '</div>';
      }
    } else {
      $html .= Event::getEventTicketsHTML($eventTickets, $settingsOption, $data->showPrice, $data->showSpots, $occurrence);
    }

    // decide if to show/hide book button
    $showBtn = false;
    foreach($allDates as $occur) {
      $occurPassed = Event::occurenceHasPassed($occurrence) ;
      if ($occurPassed || (!$occurPassed && Event::bookingOpen($occurrence) > 0)) continue;

      foreach($eventTickets as $ticketInfo) {
        if (Event::checkSpots($occur->id, $ticketInfo->id) >0) {
            $showBtn = true;
            break;
        }
      }
    }

    $pattern = '/[%=]/';
    $activeGatewaysArr = preg_split($pattern, $data->gateways);
    $showBtn = ($showBtn && ($data->paypal== "true" || $data->modal== "true" || in_array('true', $activeGatewaysArr) )) ;
    $modals = '';

    if ($showBtn) {
      $bookingBtn = Event::getModalBtn($id, $occurrence, $date_id, $dateId, true, $settingsOption["btn"],
        $settingsOption["btnTxt"], $settingsOption["settings"]->bookingStartsTxts, $settingsOption["settings"]->bookingEndedTxt, $settingsOption["dateFormat"], $settingsOption["timeFormat"]);
      $html .= $bookingBtn['html'];
      $modals .= $bookingBtn['modal'];
    }

    if ($settingsOption['settings']->addToCalendar == "true") {

      $startDate = $dateMarkUp["occurrence"]->start_date;
      $startTime = $dateMarkUp["occurrence"]->start_time;
      $endDate = $dateMarkUp["occurrence"]->end_date;
      $endTime = $dateMarkUp["occurrence"]->end_time;
      $params = array('title'=> $data->name,
        'datetime'=> array('start'=> $startDate.' '.$startTime, 'end'=> $endDate.' '.$endTime),
        'location'=> $data->mapAddress,
        'description'=> $data->info,
        'linkTxt'=> $settingsOption['settings']->addToCalendarText,
        'class'=> 'addToGoogleCal'
      );
      $gCal = new GoogleCalendar;
      $html .= '<div class= "addToCalDiv">'.$gCal->createEventReminder($params).'</div>';
    }

    $html .= '</div>';
    $modals .= Event::getBookModal($id, $date_id, $ticketID, $data);

    return  array("html"=> $html, "modal"=> $modals);
  }


  function getPayPalForm($id, $dateId, $ticket, $paypalAccount, $name, $cost, $quantity, $curr, $sandbox, $return_same_page,
    $cpp_header_image, $cpp_headerback_color, $cpp_headerborder_color, $cpp_logo_image, $cpp_payflow_color) {

    if ($sandbox == "true") {
      $uri = 'https://www.sandbox.paypal.com/cgi-bin/webscr';
    } else {
      $uri = 'https://www.paypal.com/cgi-bin/webscr';
    }

    $custom = $id;

    $form = '<form id= "paypalForm" action="'.$uri.'" method= "post" style= "display:none;">';
      $form .= '<input type= "hidden" name= "business" value="'.$paypalAccount.'">';
      $form .= '<input type= "hidden" name= "cmd" value= "_xclick">';
      $form .= '<input type= "hidden" name= "custom"  id= "custom" value="'.$custom.'">';
      $form .= '<input type= "hidden" name= "notify_url" value="'.site_url().'/paypal/paypalScript.php">';
      $form .= '<input type= "hidden" name= "cpp_header_image" value="'.$cpp_header_image.'"> ';
      $form .= '<input type= "hidden" name= "cpp_headerback_color" value="'.$cpp_headerback_color.'"> ';
      $form .= '<input type= "hidden" name= "cpp_headerborder_color" value="'.$cpp_headerborder_color.'"> ';
      $form .= '<input type= "hidden" name= "cpp_logo_image" value="'.$cpp_logo_image.'"> ';
      $form .= '<input type= "hidden" name= "cpp_payflow_color" value="'.$cpp_payflow_color.'"> ';
      $form .= '<input type= "hidden" name= "quantity" value="'.$quantity.'">';
      $form .= '<input type= "hidden" name= "item_name" value="'.$name.'">';
      $form .= '<input type= "hidden" name= "amount" value="'.$cost.'"> ';
      $form .= '<input type= "hidden" name= "currency_code" value="'.$curr.'">';
      $form .= '<input type= "hidden" name= "return" value="'.$return_same_page.'">';
    $form .= '</form>';

    return $form;
  }

  function cleanOccurences() {
    global $wpdb;

    $sql = 'DELETE FROM '.EventBookingHelpers::getTableName("eventDates").' WHERE event not in (SELECT id FROM '.EventBookingHelpers::getTableName("events").')';

    $result = $wpdb->get_results($sql);

    die($wpdb->num_rows);
  }

  function saveSettings() {
    global $wpdb;
    $dataArra =  array();
    $id = $_POST['id'];
    foreach( $_POST as $key=> $value) {
      if ($key != 'pll_ajax_backend' &&  $key != 'action' && $key != 'id') {
        $dataArra[$key]= $value;
      }
    }
    if ($id < 3) {
      $wpdb->update(EventBookingHelpers::getTableName("settings"), $dataArra, array('id'=> $id));
    } else if ($id == 8) {
      $wpdb->update(EventBookingHelpers::getTableName("settings"), $dataArra, array('id'=> '3'));
    } else {
      $wpdb->update(EventBookingHelpers::getTableName("settings"), $dataArra, array('id'=> 1 ));
      $wpdb->update(EventBookingHelpers::getTableName("settings"), $dataArra, array('id'=> 2 ));
      $wpdb->update(EventBookingHelpers::getTableName("settings"), $dataArra, array('id'=> 3 ));
    }

    die();
  }


  function saveEvent() {
    global $wpdb;

    $eventTable = EventBookingHelpers::getTableName("events");
    $eventDateTable = EventBookingHelpers::getTableName("eventDates");
    $ticketsTable = EventBookingHelpers::getTableName("tickets");

    $id = $_POST['event-id'];
    $name = (string) $_POST['name'];
    $image = (string) $_POST['image'];
    $info = (string) $_POST['info'];
    $offlineBooking = (string) $_POST['offlineBooking'];
    $paypal = (string) $_POST['paypal'];
    $showPrice = (string) $_POST['showPrice'];
    $showSpots = (string) $_POST['showSpots'];
    $occur = (string) rtrim($_POST['occur'], "|");
    $tickets = (string) rtrim($_POST['tickets'], "|");
    $mapAddressType = (string) $_POST['mapAddressType'];
    $mapAddress = (string) $_POST['mapAddress'];
    $mapZoom = (string) $_POST['mapZoom'];
    $mapType = (string) $_POST['mapType'];
    $maxSpots = (string) $_POST['maxSpots'];
    $form = (string) $_POST['form'];
    $gateways = (string) $_POST['gateways'];
    $background = (string) $_POST['background'];

    $ownerEmail = (string) $_POST['ownerEmail'];
    $ownerEmail = EventBookingHelpers::isValidEmail($ownerEmail) ? $ownerEmail : 'default';
    $emailTemplateID = (string) $_POST['emailTemplateID'];



    if ($form == "" || $form == NULL) $form = "-1";

    $isAvilable = $wpdb->get_var( "select COUNT(*) from " . $eventTable ." where id= '$id'");

    $eventData = array('name'=> $name, 'paypal'=> $paypal, 'modal'=> $offlineBooking, 'showPrice'=> $showPrice, 'showSpots'=> $showSpots, 'info'=> $info, 'mapType'=> $mapType, 'mapZoom'=> $mapZoom, 'mapAddress'=> $mapAddress, 'mapAddressType'=> $mapAddressType, 'image'=> $image, 'form'=> $form, 'maxSpots'=> $maxSpots, 'gateways'=> $gateways, 'background'=>$background, 'ownerEmail'=> $ownerEmail, 'emailTemplateID' => $emailTemplateID);

    if ($isAvilable > 0) {
      $wpdb->update($eventTable, $eventData, array('id'=> $id));
    } else {
      $eventData["id"] = $id;
      $wpdb->insert($eventTable, $eventData );
    }


    $occurIds = array();
    $split = explode('|', $occur );
    foreach($split as $occItem) {
      $final = explode(',', $occItem );
      $final[0] = $this->addEventOccurence($id, $final);
      array_push($occurIds, $final[0]);
    }


    //delete those deleted
    $results = $wpdb->get_results("SELECT * FROM " .$eventDateTable." where event= '$id'");
    foreach($results as $result) {
      if (!in_array($result->id, $occurIds))
        $wpdb->delete( $eventDateTable, array('id'=> $result->id), array('%d'));
    }

    $ticketIds = array();
    $split = explode('|', $tickets );
    foreach($split as $one) {
      $final = explode(',', $one );
      $final[0] = $this->addTicket($id, $final);
      array_push($ticketIds, $final[0]);
    }

    //delete those deleted
    $results = $wpdb->get_results("SELECT * FROM " .$ticketsTable." where event= '$id'");
    foreach($results as $result) {
      if (!in_array($result->id, $ticketIds))
        $wpdb->delete($ticketsTable, array('id'=> $result->id), array('%d'));
    }

    die();
  }

  function addTicket($id,$final) {
    global $wpdb;
    $table_name = EventBookingHelpers::getTableName("tickets");

    $data = array('name'=> $final[1], 'cost'=> $final[2], 'allowed'=> $final[3]);
    if ($final[0]!= "new") {
      $wpdb->update($table_name, $data, array("id"=> $final[0]));
      $newId = $final[0];
    } else {
      $data['event'] = $id;
      $wpdb->insert($table_name, $data);
      $newId = $wpdb->insert_id;
    }

    return $newId;
  }

  function addEventOccurence($id, $final) {
    global $wpdb;
    $table_name = EventBookingHelpers::getTableName("eventDates");

    $date_s = new DateTime($final[1]);
    $startDate = $date_s->format('Y-m-d');

    $date_e = new DateTime($final[3]);
    $endDate = $date_e->format('Y-m-d');

    $start_time = $final[2];
    $end_time = $final[4];

    $bookingDirectly = $final[5];
    $startBooking_date = $final[6];
    $startBooking_time = $final[7];

    $bookingEndsWithEvent = $final[8];
    $endBooking_date = $final[9];
    $endBooking_time = $final[10];

    $data = array(
      'start_date'=> $startDate, 'start_time'=> $start_time,
      'end_date'=> $endDate, 'end_time'=> $end_time,
      'bookingDirectly'=> $bookingDirectly, 'startBooking_date'=>$startBooking_date, 'startBooking_time'=>$startBooking_time,
      'bookingEndsWithEvent'=> $bookingEndsWithEvent, 'endBooking_date'=>$endBooking_date, 'endBooking_time'=>$endBooking_time);

    if ($final[0] != "new") {
      $wpdb->update($table_name, $data, array("id"=> $final[0]));
      $newId = $final[0];
    } else {
      $data['event'] = $id;
      $wpdb->insert($table_name, $data);
      $newId = $wpdb->insert_id;
    }

    return $newId;

  }

  function getEventOccurence($id) {
    global $wpdb;
    $table_name = EventBookingHelpers::getTableName("eventDates");
    $results = $wpdb->get_results("SELECT * FROM " . $table_name." where event= '$id' order by start_date asc, start_time asc");

    $occur = '';
    foreach($results as $result) {
      $occur .= $result->id;
      $occur .= ",".$result->start_date;
      $occur .= ",".$result->start_time;
      $occur .= ",".$result->end_date;
      $occur .= ",".$result->end_time;

      $occur .= ",".$result->bookingDirectly;
      $occur .= ",".$result->startBooking_date;
      $occur .= ",".$result->startBooking_time;
      $occur .= ",".$result->bookingEndsWithEvent;
      $occur .= ",".$result->endBooking_date;
      $occur .= ",".$result->endBooking_time;

      $occur .= "|";
    }

    return rtrim($occur, "|");
  }

  function getTickets($id) {
    global $wpdb;
    $table_name = EventBookingHelpers::getTableName("tickets");
    $results = $wpdb->get_results("SELECT * FROM " . $table_name." where event= '$id'");

    $res = '';
    foreach($results as $result) {
      $res .= $result->id;
      $res .= ",".$result->name;
      $res .= ",".$result->cost;
        $res .= ",".$result->allowed;
        $res .= "|";
    }

    return rtrim($res, "|");
  }


  function deleteEvent() {
    global $wpdb;

    $eventID = $_POST['id'];

    // delete event
    $wpdb->delete(EventBookingHelpers::getTableName("events"), array('id'=> $eventID), array('%d'));

    // delete occurrences of event
    $wpdb->delete(EventBookingHelpers::getTableName("eventDates"),  array('event'=> $eventID));

    // delete coupons of event
    $wpdb->delete(EventBookingHelpers::getTableName("eventCoupons"),  array('event'=> $eventID));

    // delete categories of event
    $wpdb->delete(EventBookingHelpers::getTableName("categoryEvents"),  array('event'=> $eventID));

    // delete tickets of event
    $wpdb->delete(EventBookingHelpers::getTableName("tickets"),  array('event'=> $eventID));

     // delete booking of event
    $wpdb->delete(EventBookingHelpers::getTableName("payments"),  array('event_id'=> $eventID));

    die($eventID);
  }


  function deleteBooking() {
    global $wpdb;

    $wpdb->delete(EventBookingHelpers::getTableName("payments"), array('id'=> $_POST['id']), array('%d'));
    $wpdb->delete(EventBookingHelpers::getTableName("couponsUsed"), array('payment'=> $_POST['id'] ),
     array('%d'));
    echo $_POST['id'];
    die();
  }

  function resendEmail () {
    EventBookingHelpers::generateEmails($_POST['id']);
    die();
  }

  function editBooking() {
    global $wpdb;
    $table_name  = EventBookingHelpers::getTableName("payments");

    $id = $_POST['id'];

    $info = $_POST['info'];
    $split = explode('|', $info);

    $came = ($split[13]) ? $split[13] : 'false';

    $fields = array(
      'ticket_id'=> $split[2],
      'type'=> $split[3],
      'coupon'=> $split[4],
      'quantity'=> $split[5],
      'name'=> $split[6],
      'email'=> $split[7],
      'extras'=> str_replace("<br/>","%",$split[8]),
      'amount'=> preg_replace('/\s+/','',str_replace("$","",$split[9])),
      'date_paid'=> $split[10],
      'txn_id'=> $split[11],
      'status'=> $split[12],
      'came' => $came);

    if ($id != "-1") {
      $wpdb->update($table_name, $fields, array( 'id'=> $id ) );
    } else {
      $fields['event_id'] = $split[0];
      $fields['date_id'] = $split[1];

      $wpdb->insert($table_name,$fields);

      echo $wpdb->insert_id;
    }

    die();
  }

  function getForms() {
    if (!AddOnManager::hasFormAddOn()) {
      $data = array ( 'forms'=> '','hasForms'=> 'false');
    } else {
      global $wpdb;
      $results = $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("forms"));

      $form = '-1,Default Form|';
      foreach($results as $result) {
        $form .= $result->id;
        $form .= ",".$result->name;
        $form .= "|";
      }

      $data = array (
         'forms'=> rtrim($form, "|"),
         'hasForms'=> 'true'
      );

    }
    return (object) $data;
  }

  function getEmailTemplates() {
    if (!AddOnManager::hasEmailTemplatesAddOn()) {
      $data = array ( 'emailTemplates'=> '','hasEmailTemplates'=> 'false');
    } else {
      global $wpdb;
      $results = $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("emailTemplates"));

      $emailTemplates = '-1,Default Email Template|';
      foreach($results as $result) {
        $emailTemplates .= $result->id;
        $emailTemplates .= ",".$result->name;
        $emailTemplates .= "|";
      }

      $data = array (
         'emailTemplates'=> rtrim($emailTemplates, "|"),
         'hasEmailTemplates'=> 'true'
      );

    }
    return (object) $data;
  }

  function ajax_getAddonsData() {
    $data = new stdClass();
    $data->formsData = $this->getForms();
    $data->emailsData = $this->getEmailTemplates();
    echo json_encode($data);

    die();
  }

  function ajax_getForms() {
    $data = $this->getForms();
    echo json_encode($data);

    die();
  }

  function getGateways($activeGateways) {
    global $wpdb;
    if ($activeGateways == NULL)
      $activeGateways = "";

    $pattern = '/[%=]/';
    $activeGatewaysArr = preg_split($pattern,$activeGateways);

    $finalGateways= $activeGateways;
    $gatewayList = $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("gateways")." where active= '1' ");
    foreach( $gatewayList as $gateway ) {
      if (!in_array($gateway->name, $activeGatewaysArr))
        $finalGateways.= "%".$gateway->name."=false";
    }

    if (strlen($finalGateways) > 0 && $finalGateways[0] == "%")
      $finalGateways = substr($finalGateways, 1, strlen($finalGateways));

    return $finalGateways;
  }

  function getEvent() {
    global $wpdb;
    $id = $_POST['event-id'];
    $result = $wpdb->get_row( "SELECT * FROM " . EventBookingHelpers::getTableName("events")." where id= '$id' ");
    $result->occur = $this->getEventOccurence($id);
    $result->tickets = $this->getTickets($id);

    $formData = $this->getForms();
    $result->forms = $formData->forms;
    $result->hasForms = $formData->hasForms;

    $emailTemplatesData = $this->getEmailTemplates();
    $result->emailTemplates = $emailTemplatesData->emailTemplates;
    $result->hasEmailTemplates = $emailTemplatesData->hasEmailTemplates;



    $result->gateways = $this->getGateways($result->gateways);

    if ($result != NULL) {
      echo json_encode($result);
    } else {
      echo "Error";
    }
    die();
  }

  function getEventShortCode() {
    global $wpdb;
    $id = $_POST['event-id'];
    echo $this->getEventOccurence($id);
    die();
  }

  function getSettings() {
    global $wpdb;
    $id = $_POST['id'];

    if ($id == 8)
      $id = 3;
    else if ($id > 2)
      $id = 1;

    $result = $wpdb->get_row("SELECT * FROM " . EventBookingHelpers::getTableName("settings")." where id= '$id' ");
    $result->hasDayListCalendar = AddOnManager::usesDayCalAddOn();
    if ($result != NULL) {
      echo json_encode($result);
    } else {
      echo "Error";
    }
    die();
  }


  function getAllCoupons() {
    global $wpdb;
    $results = $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("coupons"));
    $data = '';
    foreach( $results as $result ) {
      if ($result->isActive== "false")
        $active= "deactive";
      else
        $active= "";

      $data .= '<a href="#" class= "coupon editCoupon '.$active.'" data-id="'.$result->id.'">'.stripslashes($result->name).'</a>';

    }

    $couponCount = intval($wpdb->get_var( "select max(id) from " . EventBookingHelpers::getTableName("coupons") ))+1;
    $data .= '<a href="#" class= "coupon newCoupon" data-id="'.$couponCount.'">+ Add New Coupon</a>';
    echo $data;
    die();
  }

  function getCoupon() {
    global $wpdb;
    $id = $_POST['coupon-id'];
    $result = $wpdb->get_row( "SELECT * FROM " . EventBookingHelpers::getTableName("coupons")." where id= '$id' ");
    if ($result != NULL) {
      echo json_encode($result);
    } else {
      echo "Error";
    }
    die();
  }

  function saveCoupon() {
        global $wpdb;
        $table_name = EventBookingHelpers::getTableName("coupons");

        $id = $_POST['id'];
        $name = $_POST['name'];
        $amount = $_POST['amount'];
        $code = $_POST['code'];
        $type = $_POST['type'];
        $maxAllowed = $_POST['maxAllowed'];
        $isActive = $_POST['isActive'];

        $valid = $wpdb->get_var( "select COUNT(*) from " . $table_name ." where code= '$code' and id<>'$id'");
        if ($valid > 0) {
          echo "codeError";
          die();
        }

        $isAvilable = $wpdb->get_var( "select COUNT(*) from " . $table_name ." where id= '$id'");

        $couponData = array('name'=> $name, 'amount'=> $amount, 'code'=> $code, 'type'=> $type,
          'isActive'=> $isActive, 'maxAllowed'=> $maxAllowed );

        if ($isAvilable > 0) {
           $wpdb->update($table_name, $couponData, array('id'=> $id) );
        } else {
          $couponData['id'] = $id;
          $wpdb->insert($table_name, $couponData);
        }

        $couponCount = intval($wpdb->get_var( "select max(id) from " . $table_name ))+1;

        echo $couponCount;
        die();
  }

  function deleteCoupon() {
    global $wpdb;
    $table_name = EventBookingHelpers::getTableName("coupons");
    $wpdb->delete( $table_name, array( 'id'=> $_POST['id'] ), array( '%d' ) );
    echo $_POST['id'];
    die();
  }

  function getEventCoupons() {
    global $wpdb;
    $results = $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("coupons"));
    $event = $_POST['event-id'];
    $data = '<div class= "coupons">';
      foreach( $results as $result ) {
        $id = $result->id;
        $active = "notselected";
        $isAvilable = $wpdb->get_var( "select COUNT(*) from ". EventBookingHelpers::getTableName("eventCoupons")." where event= '$event' and coupon= '$id'");
        if ($isAvilable > 0)
          $active = "";

                $data .= '<a href="#" class= "coupon toggle '.$active.'" data-id="'.$id.'">'.stripslashes($result->name).' ( '.$result->amount.' ) - code: '.$result->code.'</a>';
      }
    $data .= '</div>';
    echo $data;
    die();
  }

  function updateEventCoupon() {
    global $wpdb;
    $event = $_POST['id'];
    $coupon = '';
    $table_name = EventBookingHelpers::getTableName("eventCoupons");
    foreach( $_POST as $key=> $value) {
      list($type, $id) = explode('-', $key);
      if ($type == "couponid") {
        $coupon= $value;
      } else if ($type == "selected") {
        if ($value == "false") {
          $isAvilable = $wpdb->get_var( "select COUNT(*) from " . $table_name ." where event= '$event' and coupon= '$coupon'");
          if ($isAvilable == 0)
             $wpdb->insert($table_name, array('event'=> $event, 'coupon'=> $coupon));

        } else if ($value == "true") {
          $wpdb->delete( $table_name, array( 'event'=> $event, 'coupon'=> $coupon ) );
        }
      }
    }
    die();
  }

  function checkCoupon() {
    global $wpdb;
    $event = $_POST['event'];
    $code = $_POST['code'];

    $settings = $wpdb->get_row("select currency, priceThousandsSep, currencyBefore, priceDecimalCount, priceDecPoint  from ". EventBookingHelpers::getTableName("settings")." where id=1");

    $curSymbol = EventBookingHelpers::getSymbol($settings->currency);

    $coupon = $wpdb->get_row("select * from ". EventBookingHelpers::getTableName("coupons")." where code='$code'");

    if($wpdb->num_rows < 1) die('false&');

    if ($coupon->isActive == 'false') die('expired&');

    $couponid = $coupon->id;

    $returnVal = $couponid . '-' . $coupon->type . '&';

    $isAvailable = $wpdb->get_var("select COUNT(*) from ". EventBookingHelpers::getTableName("eventCoupons")." where event= '$event' and coupon= '$couponid'");

    $couponUsed = $wpdb->get_var("select COUNT(*) from ". EventBookingHelpers::getTableName("couponsUsed")." where coupon='$couponid'");

    if (intval($coupon->maxAllowed) >= 0 && intval($coupon->maxAllowed) <=  intval($couponUsed)) {
      $returnVal = 'expired&';
    } else if ($isAvailable > 0) {
      if (strpos($coupon->amount, '%') !== false) {
        $returnVal .= stripslashes($coupon->name)." - Discount of <strong>".$coupon->amount.'</strong>';
      } else {
        $returnVal .=  stripslashes($coupon->name).' - Discount of '.EventBookingHelpers::currencyPricingFormat($coupon->amount, $curSymbol,
          $settings->currencyBefore, $settings->priceDecimalCount, $settings->priceDecPoint, $settings->priceThousandsSep,
          '<strong>%cost%</strong>');
      }
    } else {
      $returnVal = 'false&';
    }

    die($returnVal);
  }

  function getAllCategories() {
    global $wpdb;
    $results = $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("categories"));
    $data = '';

    foreach($results as $result)
      $data .= '<a href="#" class= "category editCategory" data-id="'.$result->id.'">'.stripslashes($result->name).' (ID: '.$result->id.')</a>';

    $maxID = intval($wpdb->get_var( "select max(id) from " . EventBookingHelpers::getTableName("categories") ))+1;

    $data .= '<a href="#" class= "category newCategory" data-id="'.$maxID.'">+ Add New Category</a>';
    echo $data;
    die();
  }

  function getCategory() {
    global $wpdb;
    $id = $_POST['id'];
    $result = $wpdb->get_row( "SELECT * FROM " . EventBookingHelpers::getTableName("categories")." where id= '$id' ");
    if ($result != NULL) {
      echo json_encode($result);
    } else {
      echo "Error";
    }

    die();
  }

  function saveCategory() {
    global $wpdb;
    $table_name = EventBookingHelpers::getTableName("categories");

    $id = $_POST['id'];
    $name = $_POST['name'];

    $isAvilable = $wpdb->get_var( "select COUNT(*) from " . $table_name ." where id= '$id'");

    if ($isAvilable > 0)
        $wpdb->update($table_name, array('name'=> $name), array( 'id'=> $id ) );
    else
        $wpdb->insert($table_name, array('id'=> $id, 'name'=> $name));

    $maxID = intval($wpdb->get_var( "select max(id) from " . $table_name ))+1;

    echo $maxID;
    die();
  }


  function deleteCategory() {
    global $wpdb;
    $categoriesTable = EventBookingHelpers::getTableName("categories");
    $categoryEventsTable = EventBookingHelpers::getTableName("categoryEvents");
    $wpdb->delete( $categoriesTable, array('id'=> $_POST['id'] ), array( '%d' ) );
    $wpdb->delete( $categoryEventsTable, array('category'=> $_POST['id'] ), array( '%d' ) );
    echo $_POST['id'];
    die();
  }

  function getEventCategories() {
    global $wpdb;
    $categoriesTable = EventBookingHelpers::getTableName("categories");
    $categoryEventsTable = EventBookingHelpers::getTableName("categoryEvents");
    $results = $wpdb->get_results( "SELECT * FROM " . $categoriesTable);
    $event = $_POST['event-id'];
    $data = '<div class= "categories">';

    foreach ($results as $result ) {
      $id = $result->id;

      $active = "notselected";
      $isAvilable = $wpdb->get_var( "select COUNT(*) from ". $categoryEventsTable." where event= '$event' and category= '$id'");
      if ($isAvilable > 0) $active = "";

      $data .= '<a href="#" class= "category toggle '.$active.'" data-id="'.$id.'">'.stripslashes($result->name).' (ID: '.$id.')</a>';
    }

    $data .= '</div>';
    echo $data;
    die();
  }

  function updateEventCategories() {
    global $wpdb;
    $event = $_POST['id'];
    $category = '';
    $categoryEventsTable = EventBookingHelpers::getTableName("categoryEvents");

    foreach( $_POST as $key=> $value) {
      list($type, $id) = explode('-', $key);

      if ($type == "categoryid") {
          $category = $value;
      } else if ($type == "selected") {
        if ($value == "false") {
          $isAvilable = $wpdb->get_var( "select COUNT(*) from " . $categoryEventsTable ." where event= '$event' and category= '$category'");

          if ($isAvilable == 0)
            $wpdb->insert($categoryEventsTable, array('event'=> $event, 'category'=> $category));

        } else if ($value == "true") {
          $wpdb->delete( $categoryEventsTable, array( 'event'=> $event, 'category'=> $category ) );
        }
      }
    }
    die();
  }

  function ajax_checkSpots() {
    $date_id = $_POST['date_id'];
    $ticket = $_POST['ticket'];
    echo Event::checkSpots($date_id,$ticket);
    die();
  }

  function getBookingMarkUp() {
    global $wpdb;
    $id = $_POST['event-id'];
    $date_id = -1;

    $settings = $wpdb->get_row( "SELECT * FROM " . EventBookingHelpers::getTableName("settings")." where id=1 ");

    $bookingDates = $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("eventDates")." where event= '$id' order by start_date asc");

    $html = '<div>';

    $html .= '<input name= "ajaxlink" value="'.site_url().'" type= "hidden"  />';
      $html .= '<div style= "margin:10px 0px; border-bottom:1px solid #eee; padding-bottom:10px;">';
          $html .= '<span style= "display:inline-block;  line-height:40px;  margin-right:15px; font-weight:700;">Bookings for date: </span>';

        $selHtml = '<select id= "ticketDateIDSELECT" class= "ticketDate">';
          $first = 0;
          foreach($bookingDates as $dateRow) {
              $first++;
              $date = new DateTime($dateRow->start_date);
              $startDate = $date->format($settings->dateFormat);
              $startTime =date($settings->timeFormat, strtotime($dateRow->start_time));
              if ($first == 1) {
                $selHtml .= '<option value="'.$dateRow->id.'" selected data-startTime="'.$startTime.'">'.$startDate.' @ '.$startTime.'</option>';
                $date_id = $dateRow->id;
              }
              else
                $selHtml .= '<option value="'.$dateRow->id.'" data-startTime="'.$startTime.'">'.$startDate.' @ '.$startTime.'</option>';
          }

          $selHtml .= '</select>';

          if ($first > 1)
            $html .= $selHtml;
          else if ($first == 1)
            $html .= '<div style= "font-size:14px; margin-left:15px; display:inline-block; line-height:40px;">'.$startDate.'</div>';
          else
            $html .= '<input type= "hidden" id= "ticketDate" value= "-1" />';

          $html .= '<a href= "#" id= "addNewBooking" class= "btn btn-primary">Add Booking</a>';

      $html .= '</div>';

      $html .= '<select style= "display:none" id= "availabeTickets">';

      $eventTickets = $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("tickets")." where event='$id' order by id asc");
      foreach($eventTickets as $ticketData) {
        $html .= '<option value="'.$ticketData->id.'" data-cost="'.$ticketData->cost.'" >'.$ticketData->name.'</option>';
      }
      $html .= '</select>';

      $html .= '<select style= "display:none" id="availabeCoupons">';
        $html .= '<option value="" data-cost="0"  data-type="" selected="selected">----Select coupon---</option>';
      $couponResults = $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("coupons"));
        foreach( $couponResults as $result_c ) {
          $c_id = $result_c->id;

          $isAvilable = $wpdb->get_var( "select COUNT(*) from ". EventBookingHelpers::getTableName("eventCoupons")." where event='$id' and coupon='$c_id'");

          if ($isAvilable > 0) {
            $html .= '<option value="'.$result_c->name.'" data-amount="'.$result_c->amount.'"  data-type="'.$result_c->type.'" >'.$result_c->name.'</option>';
          }
        }

      $html .= '</select>';

      $html .= '<div class= "alert alert-warning noRecords" style= "margin-top:20px;">No Bookings Yet!</div>';

      $html .= '<div class= "bookings">'.$this->getBooking($date_id).'</div>';
      $html .= '<div style="overflow: hidden; margin-bottom: 20px;"><em class="right">Tip: Scroll left/right: You can edit/delete bookings.</em></div>';

      if (!AddOnManager::usesAnalyticsAddOn()) {
        $html .= '<div class="alert alert-info">';
          $html .='<a href="http://iplusstd.com/item/eventBookingPro/buyAllBookings.php">';
          $html .= 'Check "Analytics and Check-in Addon" for more advanced features.';
          $html .= '</a>';
        $html .= '</div>';
      }

    $html .= '</div>';

    die($html);
  }

  function getBookingEcho() {
    echo $this->getBooking($_POST['id']);
    die();
  }

  function getBooking($date_id) {
    global $wpdb;
    $results= $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("payments")." where date_id= '$date_id' order by id desc");
    $event_id=-1;
    foreach( $results as $result ) {
      $event_id= $result->event_id;
      break;
    }
    $settings = $wpdb->get_row( "SELECT * FROM " . EventBookingHelpers::getTableName("settings")." where id=1 ");

    $curSymbol = EventBookingHelpers::getSymbol($settings->currency);

    $data = '';

    $data .= '<input type= "hidden" name= "data_id" value="'.$date_id.'" />';

    $data .= ' <table class= "table table-hover table-striped" style= "text-align:center;">';
      $data .= '<thead>';

        $data .= '<th >ID</th>';
        $data .= '<th >Ticket</th>';
        $data .= '<th >Type</th>';
        $data .= '<th >Coupon</th>';
        $data .= '<th >Quantity</th>';
        $data .= '<th >Name</th>';
        $data .= '<th >Email</th>';
        $data .= '<th >Details</th>';
        $data .= '<th >Amount</th>';
        $data .= '<th >Date</th>';
        $data .= '<th >Payment ID</th>';
        $data .= '<th >Status</th>';
        $data .= '<th >Edit</th>';
        $data .= '<th >Remove</th>';
        $data .= '<th >Resend email</th>';
    $data .= '</thead>';
         $data .= '<tbody>';
      foreach( $results as $result ) {
        $extraClass = ($result->status== "pending") ? 'class= "warning"' : '';

        $ticketID = $result->ticket_id;
        $ticket = $wpdb->get_row( "SELECT * FROM " . EventBookingHelpers::getTableName("tickets")." where id= '$ticketID'");
        $ticketName = ($ticket != NULL) ? stripslashes($ticket->name) : '';

        $data .= '<tr '.$extraClass.'>';
        $data .= '<td >'.$result->id.'</td>';
        $data .= '<td >'.$ticketName.'</td>';
        $data .= '<td >'.$result->type.'</td>';
        $data .= '<td >'.$result->coupon.'</td>';
        $data .= '<td >'.$result->quantity.'</td>';
        $data .= '<td >'.$result->name.'</td>';
        $data .= '<td >'.$result->email.'</td>';
        $data .= '<td class= "detailsCell" >'.rtrim(str_replace("%","<br/>",$result->extras), ",").'</td>';
        $data .= '<td >'.EventBookingHelpers::currencyPricingFormat($result->amount,
          $curSymbol, $settings->currencyBefore, $settings->priceDecimalCount,
          $settings->priceDecPoint, $settings->priceThousandsSep, '%cost%').'</td>';
        $data .= '<td >'.$result->date_paid.'</td>';
        $data .= '<td >'.$result->txn_id.'</td>';

        if ($result->status == "Not Paid")
          $data .= '<td ><a href= "#" class= "markPaid" data-id="'.$result->id.'" >'.$result->status.'</a></td>';
        else
          $data .= '<td >'.$result->status.'</td>';


        $data .= '<td style= "text-align:center;" class="dontInclude"><a href= "#" class= "editBooking"></a></td>';

        $data .= '<td style= "text-align:center;" class="dontInclude"><a href= "#" class= "deleteBooking">x</a></td>';

        $data .= '<td style= "text-align:center;" class="dontInclude"><a href= "#" class= "resendEmail">Resend email</a></td>';

        $data .= '</tr>';
      }

    $data .= '</tbody></table>';
    return $data;
  }

  function checkAddons() {
    echo  AddOnManager::getAddonsPage();
    die();
  }

  function ajax_markPaid() {
    global $wpdb;
    $id = $_POST['id'];
    $wpdb->update(EventBookingHelpers::getTableName("payments"), array("status"=> "Paid") ,
     array( 'id'=> $id ), '%s','%d');
  }

  function doEventBooking() {
    global $wpdb;
    $date = new DateTime();
    $payment_date = $date->format('Y-m-d');

    $id = $_POST['eventid'];
    $ticket = $_POST['ticket'];
    $dateid = $_POST['dateid'];
    $coupon = $_POST['coupon'];
    $couponID = $_POST['couponID'];
    $amount = $_POST['amount'];
    $bookName = $_POST['bookName'];
    $bookEmail = $_POST['bookEmail'];
    $quantity = $_POST['quantity'];
    $formStuff =  $_POST['formStuff'];
    $currentPage =  $_POST['currentPage'];
    $eventName =  $_POST['eventName'];

    $bookingType = $_POST['bookingType'];

    if ($coupon == '' || $coupon == NULL) $coupon= 'N.A.';

    $address = 'N.A.';
    $phone = 'N.A.';

    $paymentTable = EventBookingHelpers::getTableName("payments");

    $settings = $wpdb->get_row( "SELECT modalSpotsLeftTxt, limitBookingPerEmail, limitBookingPerEmailCount, bookingLimitText, limitBookingPerTime, limitBookingPerTimeCount, bookingLimitTimeText FROM " . EventBookingHelpers::getTableName("settings")." where id=1 ");

    $bookingsPerEmail = $wpdb->get_results("SELECT quantity FROM ".$paymentTable ." where date_id='$dateid' and email='$bookEmail'");
    $bookingCount = intval($wpdb->num_rows);

    // check if person can book
    // check if booking allowed
    if ($settings->limitBookingPerTime == 'true') {
      $limitPerTime = intval($settings->limitBookingPerTimeCount);

      if ($limitPerTime < $quantity) {
        $msg = str_replace('%left%', $bookingsLeft, $settings->bookingLimitTimeText);

        die('error&'.$msg);
      }
    }

    // check if person can book
    // check if quantity allowed
    if ($settings->limitBookingPerEmail == 'true') {
      $bookingsLeft = intval($settings->limitBookingPerEmailCount);

      foreach($bookingsPerEmail as $booking) {
        $bookingsLeft -= intval($booking->quantity);
      }

      if ($bookingsLeft < 0) $bookingsLeft = 0;
      if ($bookingsLeft < $quantity) {
        $msg = str_replace('%left%', $bookingsLeft, $settings->bookingLimitText);

        die('error&'.$msg);
      }
    }

    //check if quantity is still available.
    $totalAllowed = intval(Event::checkSpots($dateid,$ticket));

    if (intval($quantity) > $totalAllowed) {
        $msg = 'Unsuccessful! '.$settings->modalSpotsLeftTxt.' '.$totalAllowed;
        die('error&'.$msg);
    }

    $status = ($bookingType == "site") ? 'Not Paid' : 'Pending';

    $wpdb->insert($paymentTable,
      array(
        'event_id'=> $id,
        'date_id'=> $dateid,
        'ticket_id'=> $ticket,
        'coupon'=> $coupon,
        'date_paid'=> $payment_date,
        'type'=> $bookingType,
        'name'=> $bookName,
        'email'=> $bookEmail,
        'phone'=> $phone,
        'address'=> $address,
        'txn_id'=> 'N.A',
        'amount'=> $amount,
        'quantity'=> $quantity,
        'status'=> $status,
        'extras'=> $formStuff)
    );

    $paymentID = $wpdb->insert_id;

    if ($couponID != '' && $couponID != NULL) {
      $wpdb->insert(EventBookingHelpers::getTableName("couponsUsed"),
        array('coupon'=> $couponID, 'payment'=> $paymentID, 'date_used'=>$payment_date));
    }

    switch($bookingType) {
      case 'site':
        EventBookingHelpers::generateEmails($paymentID, "booking");
        echo 'site&done';
        die();

      break;

      case 'paypal':

        $settingsOption = EventBookingHelpers::getStyling(100, 1);

        if ($settingsOption["settings"]->return_same_page == "false")
          $return_page_url = $settingsOption["settings"]->return_page_url;
        else
          $return_page_url = $currentPage;

        $html = 'form&'.$this->getPayPalForm($paymentID, $dateid, $ticket, $settingsOption["paypalAccount"], $eventName, ($amount/$quantity), $quantity,
          $settingsOption["currency"], $settingsOption["sandbox"], $return_page_url,
          $settingsOption["cpp_header_image"], $settingsOption["cpp_headerback_color"], $settingsOption["cpp_headerborder_color"], $settingsOption["cpp_logo_image"], $settingsOption["cpp_payflow_color"]);

        echo $html;
        die();
      break;

      default:
        $gatewayInfo = $wpdb->get_row( "SELECT * FROM " . EventBookingHelpers::getTableName("gateways")." where name= '$bookingType'");
        $module = $gatewayInfo->module."Helpers";
        require_once(ABSPATH . 'wp-content/plugins/'.$gatewayInfo->module.'/'.$module . ".php");
        $gatewayObj = new $module;
        $gatewayType = $gatewayObj->getType();

        switch($gatewayType) {
          case "book":
          break;

          case "form":
            echo 'form&'.$gatewayObj->getPayForm($paymentID);
          break;

          case "url":
            echo 'url&'.$gatewayObj->getURL($paymentID);
          break;
        }
      break;
    }
    die();
  }

  function admin_page() {
    include_once($this->path . '/pages/admin.php');
  }

  function curPageURL() {
    $pageURL = 'http';
    if ($_SERVER["HTTPS"] == "on") {$pageURL .= "s";}
    $pageURL .= "://";

    if ($_SERVER["SERVER_PORT"] != "80") {
      $pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];
    } else {
      $pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
    }
    return $pageURL;
  }

  function testEmail() {
    global $wpdb;
    $settings = $wpdb->get_row( "SELECT * FROM " . EventBookingHelpers::getTableName("settings")." where id=1 ");

    $msg = EventBookingHelpers::sendEmail($settings->SMTP_NAME, $settings->SMTP_EMAIL,
     "Event Booking Pro Plugin Test","The email system is working!");

    if ($msg == "sent") {
      echo "No problems occure, You should recieve an email to your inbox!";
    } else {
      echo $msg;
    }
    die();
  }

  function ajax_getDefaultOwnerTemplate() {
    echo $this->getDefaultOwnerEmailTemplate();
    die();
  }

  function ajax_getDefaultTemplate() {
    echo $this->getDefaultEmailTemplate();
    die();
  }

  function getDefaultEmailTemplate() {
    return  '<html>
    <table width= "100%" border= "0" cellpadding= "20" cellspacing= "0" >
    <tr bgcolor= "#0099CC">
      <td align= "center" bgcolor= "#0099CC"><h1 style= "color:#FFF;">Email Title</h1></td>
    </tr>
    <tr>
      <td><h3>Dear %payer_name%,</h3>
      <p>This is an email to confirm that you booked %quantity% %ticketName% tickets for the event <b>%eventname%</b> for a total of %currency% %payment_amount%.</p>
      %couponMarkUp%
      <p>The event starts at %start_time% on %startDate%.</p>
      <p>Do not be late</p></td>
    </tr>
    <tr>
      <td style= "color:#333333;">Looking forward to seeing you.</td>
    </tr>
    </table></html>';
  }

  function getDefaultOwnerEmailTemplate() {
    return  '<html><table width= "100%" border= "0" cellpadding= "20" cellspacing= "0" >
      <tr>

      <td><h3>A booking (%bookingType%) just occured!</h3></p>
      <h4>Event: %eventname% (%eventid%)</h4>
      <em>Booking ID: </em> %paymentID%
      <br/><br/><em>Date:</em> %startDate% ( Date ID: %dateID%)
      <br/><br/><em>Start Time:</em> %start_time%
      <br/><em>Ticket:</em> %ticketName% (%ticketID%)
      <br/><em>Quantity:</em> %quantity%
      <br/><em>Coupon:</em> %couponMarkUp%
      <br/><em>Total Amount Due:</em> %payment_amount%
      <br/><br/><em>Transaction Date:</em> %paymentDate%
      <br/><em>Transaction ID:</em> %transaction_id%
      <p><h3>Details:</h3>
      <em>Name:</em> %payer_name%
      <br/><em>Email:</em> %payer_email%
      <br/><h3>Extra Fields:</h3>%allExtraFields%
      </td>
    </tr></table></html>';
  }

}

?>
