<?php
require_once dirname( __FILE__ ) . '/helpers.php';
require_once dirname( __FILE__ ) . '/Event.php';

class EventCard {

	public static function getCardStyle() {
		global $wpdb;
		$settings = $wpdb->get_row( "SELECT * FROM " . EventBookingHelpers::getTableName("settings")." where id='3' ");
		$style = '<style>';

		if ($settings->boxAlign == "true")
			$boxAlign = 'margin: auto; margin-top: '.$settings->boxMarginTop.'px; margin-bottom: '.$settings->boxMarginBottom.'px;';
		else
			$boxAlign = 'margin: '.$settings->boxMarginTop.'px '.$settings->boxMarginSides.'px; margin-bottom: '.$settings->boxMarginBottom.'px;';

			$style .= '.eventCardCnt{max-width:'.(intval($settings->boxWidth)+2*intval($settings->boxPaddingSides)).'px; padding:'.$settings->boxPaddingTop.'px '.$settings->boxPaddingSides.'px; padding-bottom: '.$settings->boxPaddingBottom.'px;  background-color:'.EventBookingHelpers::hex2rgba($settings->boxBgColor,1).';  -webkit-border-radius: '.$settings->boxBorderRadius.'px; -moz-border-radius: '.$settings->boxBorderRadius.'px; border-radius: '.$settings->boxBorderRadius.'px; border:'.$settings->boxBorder.'px solid'.$settings->boxBorderColor.'; }';
			$style .= '.eventCardCnt:not(.extended) {'.$boxAlign.'}';
			$style .= '.eventCardCnt:hover{ background-color:'.EventBookingHelpers::hex2rgba($settings->boxBgColor,.5).'; border-left: 5px solid '.$settings->btnBgColor.';}';

			$style .= '.eventCardCnt .cntHolder{max-width:'.$settings->boxWidth.'px; }';
			$style .= '.eventCardCnt .imageHolder{-webkit-border-radius: '.$settings->boxBorderRadius.'px; -moz-border-radius: '.$settings->boxBorderRadius.'px; border-radius: '.$settings->boxBorderRadius.'px;}';

		$detailsStyle = '';
		$imageHolder = '';
		if ($settings->eventCardShowThumbnail == "true") {

			$thumbWidth = intval($settings->eventCardThumbnailWidth);
			if ($thumbWidth < 0 ) $thumbWidth = 0;
			if ($thumbWidth > 100 ) $thumbWidth = 100;

			$imageHolder = 'width: '.$thumbWidth;
			$detailsStyle = 'max-width: ';
			if (strrpos($settings->eventCardThumbnailWidth, "%") > 0) {
				$imageHolder .= '%';
				$detailsStyle .= (100 - $thumbWidth).'%';
			} else {
				$imageHolder .= 'px';
				$possibleWidth = (intval($settings->boxWidth) - 2 * intval($settings->boxPaddingSides));
				$detailsStyle .= ($possibleWidth - $thumbWidth).'px';
			}

			$imageHolder .= ' !important;';
			$detailsStyle .= ' !important;';

		} else {
			$detailsStyle = "max-width: 100% !important;";
		}


		$style .= '.eventCardCnt:not(.extended) .imageHolder{'.$imageHolder.'}';
		$style .= '.eventCardCnt:not(.extended) .details{'.$detailsStyle.'}';

		$titleAignment='text-align:'.$settings->titleTextAlign.';';
		if ($settings->titleTextAlign == "center")
			$titleAignment .= 'margin:0 auto;';

		$fontStyle=($settings->titleFontStyle == "italic")?'font-style:italic;':'font-weight:'.$settings->titleFontStyle.';';

		$style .= '.eventCardCnt .details span.title{color:'.$settings->titleColor.'; font-size:'.$settings->titleFontSize.'px;'.$fontStyle.$titleAignment.'}';


		$LocAlign='text-align:'.$settings->locationTextAlign.';';
		if ($settings->locationTextAlign=="center")
			$titleAignment .= 'margin:0 auto;';

		$fontStyle=($settings->locationFontStyle == "italic")?'font-style:italic;':'font-weight:'.$settings->locationFontStyle.';';

		$style .= '.eventCardCnt .details span.location a{color:'.$settings->locationColor.'; font-size:'.$settings->locationFontSize.'px;'.$fontStyle.$LocAlign.'}';

		//details
		$fontStyle=($settings->detailsFontStyle == "italic")?'font-style:italic;':'font-weight:'.$settings->detailsFontStyle.';';

		$style .= '.eventCardCnt .eventDetails .price{color:'.$settings->detailsColor.'; font-size:'.$settings->detailsFontSize.'px;'.$fontStyle .';}';


		$fontStyle=($settings->detailsLabelStyle == "italic")?'font-style:italic;':'font-weight:'.$settings->detailsLabelStyle.';';

		$style .= '.eventCardCnt .eventDetails .passedEvent,.eventCardCnt .eventDetails .spots {color:'.$settings->detailsLableColor.'; font-size:'.$settings->detailsLableSize.'px;'.$fontStyle.'}';

		$boxAlign='margin: 0 auto; margin-top: '.$settings->btnMarginTop.'px; margin-bottom:'.$settings->btnMarginBottom.'px;';

		$style .= '.buyCnt a.buyBtn{background-color:'.$settings->btnBgColor.'; color:'.$settings->btnColor.'; font-size:'.$settings->btnFontSize.'px;  padding:'.$settings->btnTopPadding.'px '.$settings->btnSidePadding.'px; font-weight:'.$settings->btnFontType.';  -webkit-border-radius: '.$settings->btnBorderRadius.'px; -moz-border-radius: '.$settings->btnBorderRadius.'px;border-radius: '.$settings->btnBorderRadius.'px; border-top:'.$settings->btnBorder.'px solid'.$settings->btnBorderColor.';'.$boxAlign.'}';
		$style .= '.ebp_btn_people,.ebp_btn_people:hover{color:'.$settings->btnBgColor.';}';
		$style .= '</style>';
		return $style;
	}


	public static function getCard($id, $date_id, $width) {
		global $wpdb;

		$data = $wpdb->get_row( "SELECT * FROM " . EventBookingHelpers::getTableName("events")." where id='$id' ");
		$settingsOption = EventBookingHelpers::getStyling($width,3);
		$curSymbol = EventBookingHelpers::getSymbol($settingsOption["currency"]);

		if ($data != NULL) {
			$html = EventBookingHelpers::getModalStyles($settingsOption["settings"]);

			$html .= self::getCardStyle();
			$widthStyle = "";

			if ($width != "" && $width != NULL) {
				$widthStyle = 'style="max-width:'.$width.'px"';
			}

			$eventClasses = Event::eventIdentificationClasses($id);

			$bgStyle = '';
			$bgImageArr = explode('__and__', $data->background);
			$bgImage = $bgImageArr[0];
			if ($settingsOption["settings"]->eventCardImageAsBackground == "true" && $bgImage != "") {
				$bgStyle = 'style=" background: '.$settingsOption["settings"]->boxBgColor.' url('.$bgImage.') center center no-repeat;"';
			}


			$html .= '<div '.$bgStyle .' class="eventCardCnt lite eventDisplayCnt '.$eventClasses.'" '.$widthStyle.'>';

			$html .= '<div class="cntHolder" '.$widthStyle.'>';

			// image
			if ($settingsOption["settings"]->eventCardShowThumbnail =="true" && $data->image!=""){

				$html .= '<div class="imageHolder"><img src="'.$data->image.'"/></div>';
			}


			$html .= '<div class="details">';
			// tittle

			$html .= '<span class="title">'.stripslashes($data->name).'</span>';

			// date
			$dateId = $date_id;
			$today = date('Y-m-d');
			$passedDates = $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("eventDates")." where event='$id' and  start_date<='$today' order by start_date desc");
			$upcomingDates = $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("eventDates")." where event='$id' and  start_date>='$today' order by start_date asc");
			$allDates = array_merge($passedDates, $upcomingDates);


			$dateMarkUp = Event::getEventDateMarkUp($data, $dateId, $settingsOption, $upcomingDates, $passedDates, false);

			$html .= $dateMarkUp["html"];
			$date_id = $dateMarkUp["dateID"];
			$date = $dateMarkUp["date"];
			$start_time = $dateMarkUp["start_time"];
    	$occurrence = $dateMarkUp["occurrence"];

			// location
			if ($data->mapAddress != "") {
				$address = preg_replace('/\s+/','+',$data->mapAddress);
				$html .= '<span class="location"><a href="http://maps.google.com/?q='.$address.'" target="_blank">'.$data->mapAddress.'</a></span>';
			}

			//details
			$eventTickets = $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("tickets")." where event='$id' order by id asc");
			$i = 0;
			$left = 0;

			foreach ($eventTickets as $ticketInfo) {
				$i++;
				if ($i == 1) {
					$ticketID = $ticketInfo->id;
					$cost = $ticketInfo->cost;
					$allowed = $ticketInfo->allowed;
				}
				$left += Event::checkSpots($date_id,$ticketInfo->id);
			}

			$bookingsAll = $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("payments")." where date_id='$date_id' and event_id='$id'");
			$spotsBookedAll = 0;

			foreach($bookingsAll as $bookingA) {
				if ($settingsOption["settings"]->spotsLeftStrict == "false") {
					$spotsBookedAll += intval($bookingA->quantity);
				} else {
					$bookingStatus=$bookingA->status;
					if ( strcasecmp($bookingStatus,"paid") == 0
					|| strcasecmp($bookingStatus,"not paid") == 0
					|| strcasecmp($bookingStatus,"completed") == 0
					|| strcasecmp($bookingStatus,"success") == 0
					|| strcasecmp($bookingStatus,"successful") == 0
					|| strcasecmp($bookingStatus,"success") == 0
					|| strcasecmp($bookingStatus,"successfull") == 0) {
						$spotsBookedAll+=intval($bookingA->quantity);
					}
				}
			}

			$maxSpots = intval($data->maxSpots);

			$left = ($maxSpots>0 && $maxSpots<$left) ? ($maxSpots-$spotsBookedAll) : $left;

			$showBtn = false;
			$today = date('Y-m-d');
			foreach ( $allDates as $occur ) {
					if (Event::occurenceHasPassed($occur) && Event::bookingOpen($occurrence) > 1) continue;

					foreach($eventTickets as $ticketInfo) {
						if (Event::checkSpots($occur->id,$ticketInfo->id)>0) {
							$showBtn = true;
							break;
						}
					}
				}

			$html .= '<div class="eventDetails">';

				$hasPassed = Event::occurenceHasPassed($occurrence) && Event::bookingOpen($occurrence) > 1;
					if ($data->showPrice == "true") {
						if (!$hasPassed) {
							if (intval($cost) == 0) {
								$html .= '<div class="price">'.$settingsOption["settings"]->freeTxt.'</div>';
							} else if ($data->showPrice == "true") {
								$html .= '<div class="price" >'.EventBookingHelpers::currencyPricingFormat($cost,$curSymbol,$settingsOption["settings"]->currencyBefore,$settingsOption["settings"]->priceDecimalCount,$settingsOption["settings"]->priceDecPoint,$settingsOption["settings"]->priceThousandsSep).'</div>';
							}
						}
					}

					if ($data->showSpots == "true") {
						if ($hasPassed) {
							$html .= '<div class="passedEvent">'.$settingsOption["passedTxt"].'</div>';
						} else {
							if ($left == 0) $html .= '<div class="passedEvent" >'.$settingsOption["bookedTxt"].'</div>';
							else $html .= '<div class="spots" style="">'.$left.' '.$settingsOption["spotsLeftTxt"].'</div>';
						}
					}

					$pattern = '/[%=]/';
					$activeGatewaysArr = preg_split($pattern,$data->gateways);

					$showBtn = ($showBtn && ($data->paypal=="true" || $data->modal=="true" || in_array('true', $activeGatewaysArr) )) ;

					if ($showBtn) {
						$bookingBtn = Event::getModalBtn($id, $occurrence, $date_id, $dateId, true, '',
							$settingsOption["btnTxt"], $settingsOption["settings"]->bookingStartsTxts, $settingsOption["settings"]->bookingEndedTxt, $settingsOption["dateFormat"], $settingsOption["timeFormat"], 'buyCnt');
						$html .= $bookingBtn['html'] . $bookingBtn['modal'];
					}

				$html .= '</div>';

				$html .= '</div>';
			$html .= '</div>';
			$html .= '</div>';

			// add booking modal
			$html .= Event::getBookModal($id, $date_id, $ticketID, $data);
		} else {
		  $html = '<div class="eventNotFound" style="'.$boxStyling.' width:auto;">Event Not Found!</div>';
		}


		return $html;
	}


	public static function getDefaultSettings() {
		return
  array('passedTxt' => 'Event Passed','bookedTxt' => 'No spots left','btnTxt' => 'Book','showPrice' => 'false','includeEndsOn' => 'false','imageMarginSides' => '0','imageCrop' => 'true','imageHeight' => '100','imageMarginTop' => '0','imageMarginBottom' => '0','btnColor' => '#FFFFFF','btnBgColor' => '#2ecc71','btnFontSize' => '14','btnFontType' => 'normal','btnLineHeight' => '18','btnSidePadding' => '10','btnTopPadding' => '5','btnBorder' => '0','btnBorderColor' => '#FFF','btnBorderRadius' => '3','btnMarginTop' => '0','btnMarginBottom' => '0','boxWidth' => '500','boxPaddingSides' => '15','boxPaddingTop' => '10','boxPaddingBottom' => '10','boxMarginSides' => '0','boxMarginBottom' => '20','boxAlign' => 'true','boxMarginTop' => '0','boxBgColor' => '#f9f9f9','boxBorder' => '1','boxBorderColor' => '#F2F2F2','boxBorderRadius' => '3','titleColor' => '#495468','titleFontSize' => '28','titleLineHeight' => '24','titleTextAlign' => 'left','titleFontStyle' => 'normal','titlePaddingSides' => '0','titlePaddingTop' => '10','titlePaddingBottom' => '10','titleMarginTop' => '0','titleMarginBottom' => '0','titleBottomBorder' => '0','titleBottomBorderColor' => '#EEEEEE','dateTextAlign' => 'left','datePaddingTop' => '3','datePaddingBottom' => '0','datePaddingSides' => '0','dateMarginTop' => '0','dateMarginBottom' => '5','dateColor' => '#999999','dateLableColor' => '#666666','dateLableSize' => '12','dateLabelLineHeight' => '16','dateLabelStyle' => 'normal','dateFontSize' => '14','dateFontLineHeight' => '26','dateFontStyle' => 'normal','dateBorderColor' => '#EEEEEE','dateBorderSize' => '0','moreDateTextAlign' => 'left','moreDateColor' => '#c4c4c4','moreDateSize' => '10','moreDateLineHeight' => '16','moreDateMarginTop' => '0','moreDateFontStyle' => 'italic','moreDateHoverColor' => '#a3a3a3','moreDateOn' => 'true','moreDatePassed' => 'true','moreDateUpcoming' => 'true','moreDateTxt' => 'More','moreDateSectionMarginBottom' => '30','modal_dateTitleTextAlign' => 'center','modal_dateTitlePaddingSides' => '0','modal_dateTitleMarginBottom' => '5','modal_dateTitleColor' => '#000000','modal_dateTitleFontSize' => '28','modal_dateTitleFontLineHeight' => '30','modal_dateTitleFontStyle' => 'italic','modal_dateTextAlign' => 'left','modal_datePaddingTop' => '0','modal_datePaddingBottom' => '0','modal_datePaddingSides' => '20','modal_dateMarginTop' => '10','modal_dateMarginBottom' => '10','modal_dateColor' => '#999','modal_dateLableColor' => '#f2f2f2','modal_dateLableSize' => '12','modal_dateLabelLineHeight' => '16','modal_dateLabelStyle' => 'normal','modal_dateFontSize' => '14','modal_dateFontLineHeight' => '16','modal_dateFontStyle' => 'normal','detailsPaddingTop' => '10','detailsPaddingBottom' => '10','detailsPaddingSides' => '20','detailsMarginTop' => '10','detailsMarginBottom' => '0','detailsColor' => '#999999','detailsLableColor' => '#CCC','detailsLableSize' => '18','detailsLabelLineHeight' => '32','detailsLabelStyle' => 'normal','detailsFontSize' => '26','detailsFontLineHeight' => '32','detailsFontStyle' => 'normal','detailsBorderColor' => '#EEE','detailsBorderSize' => '0','detailsBorderSide' => '0','infoMaxHeight' => '120','locationTextAlign' => 'left','locationColor' => '#111','locationFontSize' => '14','locationLineHeight' => '14','locationFontStyle' => 'normal', 'infoExpandText' => 'more','infoTextAlign' => 'left','infoColor' => '#111','infoFontSize' => '14','infoLineHeight' => '14','infoFontStyle' => 'normal','infoPaddingSides' => '20','infoPaddingTop' => '0','infoPaddingBottom' => '20','infoMarginTop' => '20','infoMarginBottom' => '20','infoBorderColor' => '#e5e5e5','infoBorderSize' => '1','modalMainColor' => '#2ecc71','modalNameTxt' => 'Name','modalEmailTxt' => 'Email Address','modalPhoneTxt' => 'Phone Number','modalAddressTxt' => 'Your Address','modal_btnTxtColor' => '#FFF','modal_btnFontSize' => '16','modal_btnLineHeight' => '16','modal_btnFontType' => 'normal','modal_btnTopPadding' => '15','modal_btnSidePadding' => '35','modal_btnMarginTop' => '30','modal_btnBorderRadius' => '6','modal_titleSize' => '48','modal_titleLineHeight' => '48','modal_titleFontType' => 'normal','modal_titleMarginBottom' => '40','modal_input_fontSize' => '16','modal_input_lineHeight' => '20','modal_input_topPadding' => '12','modal_input_space' => '10','modalBookText' => 'Pay Later','paypalBtnTxt' => 'Pay Now','requirePhone' => 'true','requireAddress' => 'true','modal_txtColor' => '#ffffff','dateFormat' => 'F jS, Y','timeFormat' => 'g:i a','endsOnTxt' => 'Ends On:','statsOnTxt' => 'Starts On:','spotsLeftTxt' => 'spots left','modalSpotsLeftTxt' => 'Spots left:','modalQuantityTxt' => 'Quantity','modalSingleCostTxt' => 'Single Cost','modalTotalCostTxt' => 'Total Cost','eventBookedTxt' => 'Event Booked!','bookingTxt' => 'Booking Event ...','ExpandTextTxt' => 'Expand','closeTextTxt' => 'Close','termsLink' => 'terms','modal_input_txtColor' => '#FFFFFF','modal_inputHover_txtColor' => '#333333','modal_input_bgColor' => '#FFFFFF','modal_inputHover_bgColorHover' => '#FFFFFF','modal_input_bgColorAlpha' => '20','modal_inputHover_bgColorAlpha' => '60','modal_selectHoverColor' => '#208f4f','modal_selectTxtHoverColor' => '#FFFFFF','currencyBefore' => 'true','emailSubject' => 'Event Booking Information','emailSSL' => 'false','mapHeight' => '150','checkBoxMarginBottom' => '20','checkBoxMarginTop' => '20','checkBoxTextColor' => '#EEE','checkBoxColor' => '#111','cal_height' => '400','applyTxt' => 'Apply','couponTxt' => 'Coupon','freeTxt' => 'Free','popupOverlayAlpha' => '100','modalOverlayColor' => '#2ecc71','return_same_page' => 'true','return_page_url' => '','infoNoButton' => 'true','calEventDayColor' => '#FFFFFF','calEventDayColorHover' => '#FFFFFF','calTodayColor' => '#2eCC71','calEventDayDotColorHover' => '#2ecc71','calEventDayDotColor' => '#DDDDDD','modal_includeTime' => 'false','eventCardShowImage' => 'true','eventDescriptionTitle' => 'Event Information','infoTitleFontSize' => '18','infoTitleColor' => '#111111','cardDescriptionBackColor' => '#f1f1f1');

	}

}




?>
