<?php
require_once dirname( __FILE__ ) . '/helpers.php';
require_once dirname( __FILE__ ) . '/Event.php';

class EventCardExtended {

	public static function getCard($id, $date_id, $width) {

		global $wpdb;
		$data = $wpdb->get_row( "SELECT * FROM " . EventBookingHelpers::getTableName("events")." where id='$id' ");
		$settingsOption = EventBookingHelpers::getStyling($width,3);
		$curSymbol = EventBookingHelpers::getSymbol($settingsOption["currency"]);

		if ($data != NULL) {
			$html = EventBookingHelpers::getModalStyles($settingsOption["settings"]);

			$html .= self::getCardStyle();

			$widthStyle = "";

			if ($width != "" && $width != NULL) {
				$widthStyle ='style="max-width:'.$width.'px"';
			}else{
				$width = $settingsOption["width"];
			}

			$eventClasses = Event::eventIdentificationClasses($id);

			$bgStyle = '';
			$bgImageArr = explode('__and__', $data->background);
			$bgImage = $bgImageArr[0];
			if ($settingsOption["settings"]->eventCardImageAsBackground == "true" && $bgImage != "") {
				$bgStyle = 'style=" background: '.$settingsOption["settings"]->boxBgColor.' url('.$bgImage.') center center no-repeat;"';
			}

			$html .= '<div class="eventCardExtendedCnt '.$eventClasses.'" '.$widthStyle.'  data-init-width="'.$width.'">';
			$html .= '<div  class="eventCardCnt lite extended eventDisplayCnt" '.$widthStyle.' >';

			if ($settingsOption["settings"]->eventCardImageAsBackground == "true" && $bgImage != "") {
				$html .= '<div class="cardBg" ><img src="'.$bgImage.'" /></div>';
			}

			$html .= '<div class="cntHolder" '.$widthStyle.'>';

			if ($settingsOption["settings"]->eventCardShowThumbnail == "true" && $data->image != "") {
				$html .= '<div class="imageHolder"><img src="'.$data->image.'"/></div>';
			}



			//title


			$html .= '<div class="details">';
			$html .= '<span class="title">'.stripslashes($data->name).'</span>';

			//date
			$dateId = $date_id;
			$today = date('Y-m-d');
			$passedDates = $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("eventDates")." where event='$id' and  start_date<='$today' order by start_date desc");
			$upcomingDates = $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("eventDates")." where event='$id' and  start_date>='$today' order by start_date asc");

			$allDates = array_merge($passedDates, $upcomingDates);

			$dateMarkUp = Event::getEventDateMarkUp($data, $dateId, $settingsOption, $upcomingDates, $passedDates, false, false);

			$html .= $dateMarkUp["html"];
			$date_id = $dateMarkUp["dateID"];
			$date = $dateMarkUp["date"];
			$start_time = $dateMarkUp["start_time"];
    	$occurrence = $dateMarkUp["occurrence"];

			if ($data->mapAddress != "") {
				$address = preg_replace('/\s+/','+',$data->mapAddress);
				$html .= '<span class="location"><a href="http://maps.google.com/?q='.$address.'" target="_blank">'.$data->mapAddress.'</a></span>';
			}

			//details

			$eventTickets = $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("tickets")." where event='$id' order by id asc");
			$i = 0;
			$left = 0;
			foreach($eventTickets as $ticketInfo) {
				$i++;
				if ($i == 1) {
					$ticketID = $ticketInfo->id;
					$cost = $ticketInfo->cost;
					$allowed = $ticketInfo->allowed;
				}
				$left += Event::checkSpots($date_id,$ticketInfo->id);

			}

			$bookingsAll = $wpdb->get_results( "SELECT * FROM " . EventBookingHelpers::getTableName("payments")." where date_id='$date_id' and event_id='$id'");
			$spotsBookedAll = 0;

			foreach($bookingsAll as $bookingA) {
				if ($settingsOption["settings"]->spotsLeftStrict == "false") {
					$spotsBookedAll += intval($bookingA->quantity);
				} else {
					$bookingStatus = $bookingA->status;
					if (strcasecmp($bookingStatus,"paid") == 0
						|| strcasecmp($bookingStatus,"not paid") == 0
						|| strcasecmp($bookingStatus,"completed") == 0
						|| strcasecmp($bookingStatus,"success") == 0
						|| strcasecmp($bookingStatus,"success") == 0
						|| strcasecmp($bookingStatus,"successful") == 0
						|| strcasecmp($bookingStatus,"successfull") == 0 )
						$spotsBookedAll += intval($bookingA->quantity);
				}
			}
			$maxSpots = intval($data->maxSpots);

			$left = ($maxSpots > 0 && $maxSpots < $left) ? ($maxSpots - $spotsBookedAll) : $left;

			$showBtn = false;
			$today = date('Y-m-d');
			foreach( $allDates as $occur ) {
					if (Event::occurenceHasPassed($occur) && Event::bookingOpen($occurrence) > 1) continue;

					foreach($eventTickets as $ticketInfo) {
						if (Event::checkSpots($occur->id,$ticketInfo->id) > 0) {
							$showBtn = true;
							break;
						}
					}
				}

			$html .= '<div class="eventDetails">';

				$hasPassed =   Event::occurenceHasPassed($occurrence) && Event::bookingOpen($occurrence) > 1;

					if ($data->showPrice == "true") {
						if (!$hasPassed) {
							if (intval($cost) == 0) {
								$html .= '<div class="price">'.$settingsOption["settings"]->freeTxt.'</div>';
							} else if ($data->showPrice == "true") {
								$html .= '<div class="price" >'.EventBookingHelpers::currencyPricingFormat($cost,$curSymbol,$settingsOption["settings"]->currencyBefore,$settingsOption["settings"]->priceDecimalCount,$settingsOption["settings"]->priceDecPoint,$settingsOption["settings"]->priceThousandsSep).'</div>';
							}
						}
					}

					if ($data->showSpots == "true") {
						if ($hasPassed) {
							$html .= '<div class="passedEvent">'.$settingsOption["passedTxt"].'</div>';
						} else {
							if ($left == 0)
								$html .= '<div class="passedEvent" >'.$settingsOption["bookedTxt"].'</div>';
							else
								$html .= '<div class="spots" style="">'.$left.' '.$settingsOption["spotsLeftTxt"].'</div>';

						}
					}

					$pattern = '/[%=]/';
					$activeGatewaysArr = preg_split($pattern,$data->gateways);

					$showBtn = ($showBtn && ($data->paypal=="true" || $data->modal=="true" || in_array('true', $activeGatewaysArr) )) ;

					if ($showBtn) {
						$bookingBtn = Event::getModalBtn($id, $occurrence, $date_id, $dateId, true, '',
							$settingsOption["btnTxt"], $settingsOption["settings"]->bookingStartsTxts, $settingsOption["settings"]->bookingEndedTxt, $settingsOption["dateFormat"], $settingsOption["timeFormat"], 'buyCnt');
						$html .= $bookingBtn['html'] . $bookingBtn['modal'];
					}

				$html .= '</div>';

				$html .= '</div>';

			$html .= '</div>';
			$html .= '<div class="arrow-down"></div>';
			$html .= '</div>';

			$html .= '<div class="eventDescription">';

					//image
					if ($settingsOption["settings"]->eventCardShowImage == 'true' && $data->image != "") {
						$html .= '<div class="eventImage"  data-image="'.$data->image.'" data-image-crop="'.$settingsOption["imageCrop"].'" data-image-height="'.$settingsOption["imageHeight"].'"  data-image-width="'.$settingsOption["imgWidth"].'" ></div>';
					}

					//info
					if ($data->info != "") {
						$html .= '<div class="infoTitle">'.$settingsOption["settings"]->eventDescriptionTitle.'</div>';
						$infoDeactive=($settingsOption["settings"]->infoNoButton=="true")?'':'deactive';
						$html .= '<div class="info '.$infoDeactive.'"  data-closeTxt="'.$settingsOption["closeTextTxt"].'" data-expandTxt="'.$settingsOption["ExpandTextTxt"].'" data-height="'.$settingsOption["infoHeight"].'">';

							$html .= '<div class="cnt">';

								$html .= stripslashes ($data->info);
							$html .= '</div>';

						$html .= '</div>';
							$html .= '<div class="cntForSpace"></div>';
					}

					//map
					if ($data->mapAddress != "") {
						$html .= '<div class="map_canvas" style="display:none; height:'.$settingsOption["settings"]->mapHeight.'px;" data-address="'.$data->mapAddress.'" data-zoom="'.$data->mapZoom.'" data-maptype="'.$data->mapType.'" data-addressType="'.$data->mapAddressType.'" ></div>';
					}

						$html .= '<a href="#" class="hideDetails"></a>';
				$html .= '</div>';

			$html .= '</div>';

			// add booking modal
			$html .= Event::getBookModal($id, $date_id, $ticketID, $data);
		} else {
		  $html ='<div class="eventNotFound" style="'.$boxStyling.' width:auto;">Event Not Found!</div>';
		}

		return $html;
	}

	public static function getCardStyle() {
		global $wpdb;
		$settings = $wpdb->get_row( "SELECT * FROM " . EventBookingHelpers::getTableName("settings")." where id='3' ");
		$style = '<style>';

		if ($settings->boxAlign=="true")
			$boxAlign='margin: 0 auto; margin-top: '.$settings->boxMarginTop.'px; margin-bottom: 0px;';
		else
			$boxAlign= 'margin: '.$settings->boxMarginTop.'px '.$settings->boxMarginSides.'px; margin-bottom:0px;';


		$style .= '.eventCardExtendedCnt{max-width:'.(intval($settings->boxWidth)+2*intval($settings->boxPaddingSides)).'px; '.$boxAlign.' padding:0;}';
			$maxAllowedWidth = (intval($settings->boxWidth) + 2 * intval($settings->boxPaddingSides));


			$bgColor = EventBookingHelpers::hex2rgba($settings->boxBgColor, 1);
			$bgColorHover = EventBookingHelpers::hex2rgba($settings->boxBgColor, .5);

			$style .= '.eventCardCnt {max-width:'.$maxAllowedWidth.'px;'.$boxAlign.'padding:'.$settings->boxPaddingTop.'px '.$settings->boxPaddingSides.'px; padding-bottom: '.$settings->boxPaddingBottom.'px;  background-color:'.$bgColor.';  -webkit-border-radius: '.$settings->boxBorderRadius.'px; -moz-border-radius: '.$settings->boxBorderRadius.'px; border-radius: '.$settings->boxBorderRadius.'px; border:'.$settings->boxBorder.'px solid'.$settings->boxBorderColor.'; }';


			$style .= '.eventCardCnt:hover{ background-color:'.$bgColorHover.'; border-left: 5px solid '.$settings->btnBgColor.';}';

			$style .= '.eventCardCnt .arrow-down {border-top-color: '.$settings->btnBgColor.';}';



			$style .= '.eventCardCnt .cntHolder{max-width:'.$settings->boxWidth.'px; }';
			$style .= '.eventCardCnt .imageHolder{-webkit-border-radius: '.$settings->boxBorderRadius.'px; -moz-border-radius: '.$settings->boxBorderRadius.'px; border-radius: '.$settings->boxBorderRadius.'px;}';

			$detailsStyle = '';
			$imageHolder = '';
			if ($settings->eventCardShowThumbnail == "true") {

				$thumbWidth = intval($settings->eventCardExpandThumbnailWidth);
				if ($thumbWidth < 0 ) $thumbWidth = 0;
				if ($thumbWidth > 100 ) $thumbWidth = 100;

				$imageHolder = 'width: '.$thumbWidth;
				$detailsStyle = 'max-width: ';
				if (strrpos($settings->eventCardExpandThumbnailWidth, "%") > 0) {
					$imageHolder .= '%';
					$detailsStyle .= (100 - $thumbWidth).'%';
				} else {
					$imageHolder .= 'px';
					$possibleWidth = (intval($settings->boxWidth) - 2 * intval($settings->boxPaddingSides));
					$detailsStyle .= ($possibleWidth - $thumbWidth).'px';
				}

				$imageHolder .= ' !important;';
				$detailsStyle .= ' !important;';

			} else {
				$detailsStyle = "max-width: 100% !important;";
			}


		$style .= '.eventCardExtendedCnt .imageHolder{'.$imageHolder.'}';
		$style .= '.eventCardExtendedCnt .details{'.$detailsStyle.'}';



		$titleAignment = 'text-align:'.$settings->titleTextAlign.';';
		if ($settings->titleTextAlign == "center")
			$titleAignment.='margin:0 auto;';

		$fontStyle=($settings->titleFontStyle == "italic")?'font-style:italic;':'font-weight:'.$settings->titleFontStyle.';';

		$style .= '.eventCardCnt .details span.title{color:'.$settings->titleColor.'; margin-bottom: '.$settings->titleMarginBottom .'px; font-size:'.$settings->titleFontSize.'px;'.$fontStyle.$titleAignment.'}';



		$LocAlign = 'text-align:'.$settings->locationTextAlign.';';
		if ($settings->locationTextAlign == "center")
			$titleAignment.='margin:0 auto;';

		$fontStyle = ($settings->locationFontStyle == "italic")?'font-style:italic;':'font-weight:'.$settings->locationFontStyle.';';


		$style .= '.eventCardCnt .details span.location a{color:'.$settings->locationColor.'; font-size:'.$settings->locationFontSize.'px;'.$fontStyle.$LocAlign.'}';


		//details
		$fontStyle = ($settings->detailsFontStyle == "italic")?'font-style:italic;':'font-weight:'.$settings->detailsFontStyle.';';

		$style .= '.eventCardCnt .eventDetails .price{color:'.$settings->detailsColor.'; font-size:'.$settings->detailsFontSize.'px;'.$fontStyle .';}';


		$fontStyle=($settings->detailsLabelStyle == "italic")?'font-style:italic;':'font-weight:'.$settings->detailsLabelStyle.';';

		$style .= '.eventCardCnt .eventDetails .passedEvent,.eventCardCnt .eventDetails .spots {color:'.$settings->detailsLableColor.'; font-size:'.$settings->detailsLableSize.'px;'.$fontStyle.'}';

		$boxAlign = 'margin: 0 auto; margin-top: '.$settings->btnMarginTop.'px; margin-bottom:'.$settings->btnMarginBottom.'px;';

		$style .= '.buyCnt a.buyBtn{background-color:'.$settings->btnBgColor.'; color:'.$settings->btnColor.'; font-size:'.$settings->btnFontSize.'px;  padding:'.$settings->btnTopPadding.'px '.$settings->btnSidePadding.'px; font-weight:'.$settings->btnFontType.';  -webkit-border-radius: '.$settings->btnBorderRadius.'px; -moz-border-radius: '.$settings->btnBorderRadius.'px;border-radius: '.$settings->btnBorderRadius.'px; border-top:'.$settings->btnBorder.'px solid'.$settings->btnBorderColor.';'.$boxAlign.'}';
		$style .= '.ebp_btn_people,.ebp_btn_people:hover{color:'.$settings->btnBgColor.';}';

		$style .= '.eventCardExtendedCnt .eventDescription{width:100%; background-color:'.EventBookingHelpers::hex2rgba($settings->cardDescriptionBackColor,1).'; padding:0px;}';

		//info
		$style .= '.eventCardExtendedCnt .eventDescription .info a.expand{background-color:'.EventBookingHelpers::hex2rgba($settings->cardDescriptionBackColor,.9).';
-webkit-box-shadow:  0px -5px 10px 0px '.EventBookingHelpers::hex2rgba($settings->cardDescriptionBackColor,.8).';
-moz-box-shadow:  0px -5px 10px 0px '.EventBookingHelpers::hex2rgba($settings->cardDescriptionBackColor,.8).';
box-shadow:  0px -5px 10px 0px rgba'.EventBookingHelpers::hex2rgba($settings->cardDescriptionBackColor,.8).'
}';

		$alignment='text-align:'.$settings->infoTextAlign.';';

		$fontStyle = ($settings->infoFontStyle == "italic")?'font-style:italic;':'font-weight:'.$settings->infoFontStyle.';';

		$style .= '.eventCardExtendedCnt .eventDescription .info{color:'.$settings->infoColor.'; font-size:'.$settings->infoFontSize.'px; line-height:'.$settings->infoLineHeight.'px;  '.$fontStyle.' padding:'.$settings->infoPaddingTop.'px '.$settings->infoPaddingSides.'px; padding-bottom:'.$settings->infoPaddingBottom.'px'.$alignment.'}' ;

		$style .= '.eventCardExtendedCnt .eventDescription .info a.expand{color:'.$settings->infoColor.'; margin-left: -'.$settings->infoPaddingSides.'px;}' ;

		$style .= '.eventCardExtendedCnt .eventDescription .infoTitle{color:'.$settings->infoTitleColor.';  font-size:'.$settings->infoTitleFontSize.'px; line-height:'.$settings->infoTitleFontSize.'px; margin:0px 0px; padding:'.$settings->infoMarginTop.'px '.$settings->infoPaddingSides.'px;}';


		$style .= '.eventCardExtendedCnt .eventDescription .cntForSpace{margin:0;padding:0; width:100%; height:'.$settings->infoPaddingBottom.'px; border-bottom:'.$settings->infoBorderSize.'px solid '.$settings->infoBorderColor.'; }';
		//margin-bottom:'.$settings->infoMarginBottom.'px;

		//image

		$style .= '.eventCardExtendedCnt .eventDescription  .eventImage{margin:0px '.$settings->imageMarginSides.'px; margin-top: '.$settings->imageMarginTop.'px; margin-bottom: '.$settings->imageMarginBottom.'px;}';


		$style .= '</style>';
		return $style;
	}

}


?>
