/* Event Booking Pro - WordPress Plugin
 * Get plugin at: http://iplusstd.com/item/eventBookingPro/
 * Moe Haydar
 */

(function($) {

$(document).ready(function() {

    if (parseInt($(".ebp-content .spotsleft span").html(),10) == 0) {
        $(".ebp-content .buy a").each(function(index, element) {
          if (!$(this).hasClass("deactive"))
            $(this).addClass("deactive");
        });
    }

    // feeable option watch and update total price on change
    $('.ebp-content  .hasRadioButton.hasFee input[type="radio"]').change(calcTotal);
    $(' .ebp-content .hasCheckBoxes.hasFee input[type="checkbox"]').change(calcTotal);
    $(' .ebp-content select.hasFee').change(calcTotal);

	$('.ebp-content .tickets select').change(function(index, element) {
		var $topLevel = $(".couponDiv");
		var eventID = $(".tickets").attr("data-id");
        var cost;
        var ticketID = $('.tickets .ticketType').val();

        if($('.tickets select.ticketType').length>0)
            cost = $('.tickets select.ticketType option:selected').attr("data-cost");
        else
            cost = $topLevel.find('input[name="initialCost"]').val();

        var Dateid = $('.tickets .ticketDate').val();
        $topLevel.find('input[name="initialCost"]').val(cost);

        calcTotal();

        $(" .ebp-content .tickets .spotsleft span").text("");

        var $opt = $('.tickets select.ticketDate option:selected')

        var bookingStatus = $opt.attr("data-bookingStatus");

        if (bookingStatus == 1) {
            $('.ebp-content .buy').hide()
            $('.ebp-content .noBuy').html($opt.attr("data-startsTxt"))
            $('.ebp-content .noBuy').show()
        } else if (bookingStatus > 1) {
            $('.ebp-content .buy').hide();
            $('.ebp-content .noBuy').html($opt.attr("data-endsTxt"))
            $('.ebp-content .noBuy').show()
        } else {
            $('.ebp-content .buy').show();
            $('.ebp-content .noBuy').hide()
        }

        $('.ebp-content .noBuy').css('line-height', $('.ebp-content .buy').height()+'px');

        $.ajax({
            type:'POST',
            url: $("input[name='ajaxlink']").val()+'/wp-admin/admin-ajax.php',
            data:'action=check_spots&ticket='+ticketID+'&date_id='+Dateid,
            success: function(response) {
                $(" .ebp-content .tickets .spotsleft span").text(response);

                var newTotal = $(" .ebp-content .single strong").text();

                $(" .ebp-content .quantityBtns span").html(1);
                $(' .ebp-content input[name="quantity"]').val(1);
                $(' .ebp-content .total strong').html(newTotal);

                calcTotal();

                if(parseInt($(" .ebp-content .spotsleft span").html()) === 0) {
                    $(" .ebp-content .buy a").each(function(index, element) {
                        if(!$(this).hasClass("deactive"))
                            $(this).addClass("deactive")
                    });
                } else if($(" .ebp-content .spotsleft span").html() != "0") {
                    $(" .ebp-content .buy a").each(function(index, element) {
                        if($(this).hasClass("deactive"))
                            $(this).removeClass("deactive");
                    });
                }
            }
        });
    });


    $(document).on('focus',".ebp-content input,.ebp-content textarea",function() {
      if ($(this).val() == $(this)[0].title) {
          $(this).removeClass("incorrect");
          $(this).val("");
      }
    });

    $(document).on('blur',".ebp-content input,.ebp-content textarea",function() {
      if ($(this).val() == "") {
          $(this).removeClass("incorrect");
          $(this).val($(this)[0].title);
      }
    });

	$(document).on('click', '.ebp-content .quantityBtns a', function(e) {

		e.preventDefault();
        var newQuantity = parseInt($('.ebp-content .quantityBtns span').html());

        if($(this).hasClass("up"))
            newQuantity ++;
        else
            newQuantity --;


        // stop if quantity exceeds the limit
        if(newQuantity < 1) return;

        if(newQuantity > parseInt($('.ebp-content .spotsleft span').html())) return;

        var initPrice = getFormattedNumber($('.ebp-content .single strong').text());
        var newTotal = newQuantity * initPrice;
        newTotal = formatPrice(newTotal)

        $('.ebp-content .quantityBtns span').html(newQuantity);
        $('.ebp-content input[name="quantity"]').val(newQuantity);

        $('.ebp-content .total strong').html(newTotal);

        calcTotal();
    });

	// checking coupon btn
	$(document).on('click', '.ebp-content .coupon.checking', function(e) {
		e.preventDefault();
        $('.ebp-content span.couponResult').html("checking...");
        var coupon = $('.ebp-content input[name="coupon-code"]').val();
        var id = $('.ebp-content input[name="event-id"]').val();

        $.ajax({
            type:'POST',
            url: $("input[name='ajaxlink']").val() + '/wp-admin/admin-ajax.php',
            data: 'action=check_coupon&code=' + coupon + '&event=' + id,
            success: function(response) {
                var id = response.substring(0, response.indexOf('-'));
                var type = response.substring(1 + response.indexOf('-'), response.indexOf('&'));
                var opt = response.substring(1 + response.indexOf('&'), response.length);

                if (type === 'expired') {
                    $('.ebp-content span.couponResult').attr("data-name", "");
                    $('.ebp-content span.couponResult').html("Coupon has expired.");
                } else if(type === 'false') {
                    $('.ebp-content span.couponResult').attr("data-name", "");
                    $('.ebp-content span.couponResult').html("Coupon not found.");
                } else {
                    $('.ebp-content span.couponResult').html(opt);
                    $('.ebp-content span.couponResult').attr("data-name", coupon);
                    $('.ebp-content span.couponResult').attr("data-type", type);
                    $('.ebp-content span.couponResult').attr("data-id", id);

                    calcTotal();
                }

            }
        });

	 });


	function calcTotal() {
        var initPrice = parseFloat($('.ebp-content input[name="initialCost"]').val().replace("," , ""));

        var quantity = parseInt($('.ebp-content .quantityBtns span').html(),10);

        var couponType = $('.ebp-content span.couponResult').attr("data-type");

        var couponAmount, couponAmountFormatted, newPrice, newTotal;

        newPrice = initPrice;
        newTotal = quantity*initPrice;

        couponAmount = $('.ebp-content span.couponResult strong').text();
        couponAmountFormatted = getFormattedNumber(couponAmount);

        if (couponType === 'single') {
            if (couponAmount.indexOf("%") > -1) {
              newPrice = initPrice - parseFloat(couponAmountFormatted) * initPrice/100;
            } else {
              newPrice = initPrice - couponAmountFormatted;
            }

            newTotal = quantity * newPrice;
        } else if (couponType === 'total') {
            if (couponAmount.indexOf("%") > -1)
              newTotal = newTotal - parseFloat(couponAmountFormatted) * newTotal/100;
            else
              newTotal = newTotal - couponAmountFormatted;

        }

    // calculate extra cost
    var totalAddedCost = 0;
    var currCost = 0;

      $('.ebp-content select.hasFee option:selected').each(function (index, element) {
        if (!isNaN($(this).attr('data-cost'))) {
              currCost = parseInt($(this).attr('data-cost'));
            if ($(this).attr('data-fee-type') == 'ticket') {
              currCost *= quantity;
            }
            totalAddedCost += currCost;
        }


      });

      $('.ebp-content .hasRadioButton.hasFee input[type="radio"]').each(function (index, element) {
        if ($(this).is(':checked')) {
            currCost = parseInt($(this).attr('data-cost'));
            if ($(this).attr('data-fee-type') == 'ticket') {
              currCost *= quantity;
            }
            totalAddedCost += currCost;
          }
      });

      $(' .ebp-content .hasCheckBoxes.hasFee').each(function (index, element) {
        $(this).find('input[type="checkbox"]').each(function (index, element) {
          if ($(this).is(':checked')) {
            currCost = parseInt($(this).attr('data-cost'));
            if ($(this).attr('data-fee-type') == 'ticket') {
              currCost *= quantity;
            }
            totalAddedCost += currCost;
          }
        });
      });
      newTotal += totalAddedCost;

        if (newTotal < 0) newTotal = 0;
        if (newPrice < 0) newPrice = 0;

        newTotal = formatPrice(newTotal);
        newPrice = formatPrice(newPrice)

        $('.ebp-content .single strong').html(newPrice);
        $('.ebp-content .total strong').html(newTotal);
        $('.ebp-content input[name="amount"]').val(newPrice);

        if ($('.ebp-content span.couponResult strong').length > 0) {
            var newName = $('.ebp-content input[name="eventName"]').val()+" - coupon: "+$('.ebp-content .optCol.double span').text();
            $('.ebp-content input[name="item_name"]').val(newName);
        }

        //

        if (initPrice === 0) {
            $('.ebp-content .single, .ebp-content .total, .ebp-content .singleLabel, .ebp-content .totalLabel, .book.paypal').hide();

        } else {
         $('.ebp-content .single, .ebp-content .total, .ebp-content .singleLabel, .ebp-content .totalLabel, .book.paypal').show();

        }

	}


	$(document).on('click', '.ebp-content .book', function(e) {

		e.preventDefault();

		if($(this).hasClass("deactive"))
		  	return;

		$(" .ebp-content .incorrect").each(function(index, element) {
            $(this).removeClass("incorrect");
        });

		var isOkay = true;
		var $this = $(this);


		 $(" .ebp-content .bookInput.isRequired").each(function(index, element) {
			 if ($(this).val() === "" || $(this).val() === $(this)[0].title) {
				isOkay = false;
				$(this).addClass("incorrect");
			 }

			  if($(this).hasClass("email") && !validateEmail($(this).val())) {
				isOkay = false;
				$(this).addClass("incorrect");
			  }

   		 });

         $(".ebp-content .fieldHolder.isRequired").each(function (index, element) {
            if ($(this).find('select').length > 0) {
                 if ($(this).find("select").val()=='none') {
                     isOkay = false;
                    $(this).find("select").addClass('incorrect');
                 }
            } else if ($(this).find("input:checked").length < 1 ) {
                isOkay = false;
                $(this).addClass('incorrect');
            }
        });

		if(!isOkay) return false;

        $(" .ebp-content .bookInput").not(".isRequired").each(function(index, element) {
             if ($(this)[0].title==$(this).val())
                    $(this).val("");
        });

        $(" .ebp-content a.book").each(function(index, element) {
            $(this).addClass("deactive")
        });

        var eventID = $(" .ebp-content input[name='eventID'] ").val();
        var ticket = $('.tickets .ticketType').val();
        var dateid = $('.tickets .ticketDate').val();


        var coupon = $(" .ebp-content .couponResult").attr("data-name");
        if(coupon == null) coupon = '';
        var couponID = $(" .ebp-content .couponResult").attr("data-id");
        if(couponID == null) couponID = '';


        var amount = getFormattedNumber($(" .ebp-content .total strong").text()) + "";
        var bookerName = $('.ebp-content input[name="name"]').val();
        var bookerName;
        if ($('.ebp-content input[name="firstName"]').length > 0) {
            bookerName = $('.ebp-content input[name="firstName"]').val();
            bookerName += ' '
            bookerName += $('.ebp-content input[name="lastName"]').val();
        } else {
            bookerName = $('.ebp-content input[name="name"]').val();
        }

        var bookerEmail = $('.ebp-content input[name="email"]').val();
        var eventName = $(" .ebp-content .title").text();
        var bookQuantity = $(" .ebp-content .quantityBtns span").html();

        $(" .ebp-content .offlineloader").html($(" .ebp-content .offlineloader").attr("data-text"));

        if ($('.mCustomScrollbar').length > 0) {
            $('').mCustomScrollbar("update");
            $('').mCustomScrollbar("scrollTo","bottom");
            $(' .ebp-content .offlineloader').show();
        } else {
            $(' .ebp-content .offlineloader').show(200);
        }

        var bookingType = "site";
        if(parseInt(amount) > 0)
            bookingType = $(this).attr("data-type");


        var extra = "";

        var formInputes ="";

        $(' .ebp-content form input[type="text"]').each(function(index, element) {
            if($(this).attr("name") != "name"  && $(this).attr("name") !="firstName" && $(this).attr("name") !="lastName" && $(this).attr("name") != "email")
               if($(this).val() != '')
                 formInputes += $(this).attr("name").replace(/:/g , "") + ": " + $(this).val() + "%";
        });


        $(".ebp-content form textarea").each(function(index, element) {
             if($(this).val() != '')
                formInputes += $(this).attr("name").replace(/:/g , "") + ": " + $(this).val() + "%";
        });

        $('.ebp-content form select').each(function(index, element) {
             if($(this).val() != 'none')
                formInputes += $(this).attr("name").replace(/:/g , "") + ": " + $(this).val() + "%";
        });

        $('.ebp-content form input[type="radio"]').each(function(index, element) {
            if($(this).is(':checked'))
                formInputes += $(this).attr("name").replace(/:/g , "") + ": " + $(this).val() + "%";
        });

        $('.ebp-content form .hasCheckBoxes').each(function(index, element) {
            if ($(this).hasClass("isTerms")) return;
            currInputs = $(this).attr("data-name").replace(/:/g , "") + ":";
            var tots = 0;

            $(this).find('input[type="checkbox"]').each(function(index, element) {

                if($(this).is(':checked')) {
                    currInputs += " "+$(this).val() + ",";
                    tots++;
                }
            });
            if(tots > 0)
                formInputes += currInputs;
        });

        formInputes = formInputes.replace(/^\,/, '');
        formInputes = '&formStuff=' + encodeURIComponent(formInputes);

        var currentPage = '&currentPage=' + document.URL;

        $.ajax({
            type: 'POST',
            url: $("input[name='ajaxlink']").val()+'/wp-admin/admin-ajax.php',
            data: 'action=doEventBooking'+'&bookingType='+bookingType+'&coupon='+coupon+'&couponID='+couponID+'&dateid='+ dateid+'&ticket='+ ticket+'&eventid='+ eventID+'&quantity='+bookQuantity+'&amount='+amount+"&eventName="+eventName+extra+formInputes+'&bookName='+ '&bookName='+bookerName +'&bookEmail='+bookerEmail+'&currentPage='+currentPage,
            error: function(response) {
                $(" .ebp-content a.book").each(function(index, element) {
                    $(this).removeClass("deactive")
                });

                $(" .ebp-content .offlineloader").html("Error Sending");
            },
            success: function(response) {
                var type = response.substring(0, response.indexOf("&"));
                var opt = response.substring(1+response.indexOf("&"), response.length);


                if (type.indexOf('error') > -1) {
                    $(".ebp-content .offlineloader").html(opt);
                    $(".ebp-content a.book").each(function(index, element) {$(this).removeClass("deactive")});
                } else if (type.indexOf('form') > -1) {
                     $(opt).appendTo('body').submit();

                } else if (type.indexOf('url') > -1) {
                    window.location.href = opt;
                } else {
                    var doRedirect = $("#successRedirect").val();
                    if(doRedirect != "")
                        window.location.href = doRedirect;

                    $(" .ebp-content .tickets .spotsleft span").text(parseInt(($(" .ebp-content .tickets .spotsleft span").text())-parseInt(bookQuantity)));

                    $(" .ebp-content a.book").each(function(index, element) {
                        $(this).removeClass("deactive")
                    });

                    $(" .ebp-content form input[type!='hidden']").each(function(index, element) {
                        $(this).val($(this).attr("title"));
                    });

                    $(" .ebp-content form textarea[type!='hidden']").each(function(index, element) {
                        $(this).val($(this).attr("title"));
                    });

                    $(" .ebp-content .offlineloader").html($(" .ebp-content .offlineloader").attr("data-text2"));
                }
            }
        });
   	 });


	function validateEmail(email) {
	    var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
	    return re.test(email);
	}

    function getFormattedNumber(x) {
        if(x == "") return 0;
        var priceDecPoint = $('.ebp-content').attr("data-priceDecPoint");
        var priceThousandsSep = $('.ebp-content').attr("data-priceThousandsSep");

        return parseFloat(x.replace(priceThousandsSep,"").replace(priceDecPoint,"."));
    }



    function formatPrice(x) {
        var priceDecPoint = $('.ebp-content').attr("data-priceDecPoint");
        var priceThousandsSep = $('.ebp-content').attr("data-priceThousandsSep");

        var priceDecLength = parseInt($('.ebp-content').attr("data-priceDecLength"));

        x = x.toFixed(priceDecLength);
        x = x.toString();

        var decPart = x.substring(x.indexOf(".")+1, x.length)
        if(priceDecLength == 0)
            decPart = 0;

        if(priceDecLength > 0)
        x = x.substring(0, x.indexOf("."))

        x = x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, priceThousandsSep)

        if(priceDecLength > 0)
        x = x+priceDecPoint+decPart;

        return x
    }

})
})(jQuery)
